<?

# Function used to print tree
function printTree ($myhtmltree, $includeItems, $CpMv) {
	$myhtmltree->printTree($includeItems, $CpMv);
}

# Function used to print items
function printItems ($myhtmltree, $includeDirs) {
	$myhtmltree->printItems("", $includeDirs, false);
}

# Function used to print selected item
function printItem ($myhtmltree) {
	$myhtmltree->printItem();
}

# Function used to show the description of an item being edited
function showDescription ($myhtmltree, $sel, $includeSysID) {

	$includeSysID = 0; //Sam Przyswa
	$text = lang('select an item');
	if ($sel && !($sel == "null")) {
		$text = $myhtmltree->getTreeText ($sel);
		$active = true;
	}
	else {
		$active = false;
		$sel = 1000001;
	}
	$text = $myhtmltree->createIMGURL ($sel, $active).$text;
	if ($includeSysID) {
		$text=$text." - sysID: ".$sel;
	}
	echo $text;
}

# This function creates the form used to create or edit objects within the HTML tree
function printObjectForm($myhtmltree,$cat,$id,$name,$owner,$group,$groupAccess,$newGroup,$privateGroup,$newGroupMembers,$worldAccess,$keywords,$updateReason,$itemText,$actn,$confirm,$dir,$htmlOptions,$itemFile,$itemFile_name,$itemFile_type,$itemFile_size,$binary) {
	if ($cat == "dirform" || $cat == "itemform") {
		$myhtmltree->printObjectForm($cat,$id,$name,$owner,$group,$groupAccess,$newGroup,$privateGroup,$newGroupMembers,$worldAccess,$keywords,$updateReason,$itemText,$actn,$confirm,$dir,$htmlOptions,$itemFile,$itemFile_name,$itemFile_type,$itemFile_size,$binary);
	}
	else {
		$myhtmltree->printObjectForm($cat,"",$name,$owner,$group,$groupAccess,$newGroup,$privateGroup,$newGroupMembers,$worldAccess,$keywords,$updateReason,$itemText,$actn,$confirm,$dir,$htmlOptions,$itemFile,$itemFile_name,$itemFile_type,$itemFile_size,$binary);
	}
}

# This function inserts an item under the specified parent
function addItem($title, $item, $parentID, $dbName, $dbServer, $userName, $password, $owner, $worldAccess, $groupId, $groupAccess) {
	
	$db = mysql_connect($dbServer, $userName, $password);
	if ($db){
		$connected = mysql_select_db($dbName,$db);
	}
	if (!$connected) {
		echo "There was an error connecting to the Database!  Please contact Technical Support.";
	}
	else {
		$sql = "SELECT iTopicItemID FROM tblID";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred1");
		$row = mysql_fetch_array ($myresult);
		$id = $row[0] + 1;
		mysql_free_result ($myresult);
		
		# Update id
		$sql = "UPDATE tblID SET iTopicItemID=".$id;
		$myresult = mysql_query ($sql)
			or die ("An error has occurred2");
	}
	if ($id) {
		if ($title == "useId") {
			$title = $id;
		}
		$sql = "INSERT INTO tblTopicItems VALUES ($id, $parentID, '$title', '$item')";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred3");
			
		$sql = "INSERT INTO tblPermissions VALUES ($id, $worldAccess)";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred4");
		
		$sql = "INSERT INTO tblOwner VALUES ($id, '$owner')";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred5");
			
		$sql = "INSERT INTO tblModified VALUES ($id, '$owner', NOW())";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred6");
			
		if ($groupId != "") {
			$sql = "INSERT INTO tblGroupPermissions VALUES ($id, $groupId, $groupAccess)";
			$myresult = mysql_query ($sql)
				or die ("An error has occurred7");
		}
		mysql_close ($db);
		return $id;
	}

}


# This function prints all of the items under the specified parent id
function printAllItems ($parentID, $dbName, $dbServer, $userName, $password, $itemsPerPage, $includeTitle, $isCSV) {
	$db = mysql_connect($dbServer, $userName, $password);
	if ($db){
		$connected = mysql_select_db($dbName,$db);
	}
	if (!$connected) {
		echo "There was an error connecting to the Database!  Please contact Technical Support.";
	}
	else {
		$sql = "SELECT sTopicItem, sTitle FROM tblTopicItems WHERE iTopicID = $parentID";
		$myresult = mysql_query ($sql)
			or die ("An error has occurred1");
		$x = 0;
		if ($isCSV) {
			echo ("<PRE>\n");
		}
		while ($row = mysql_fetch_array ($myresult)) {
			$x++;
			if ($isCSV) {
				if ($includeTitle) {
					echo ($row[1].",");
				}
				echo ($row[0]."\n");
			}
			else {
				if ($includeTitle) {
					echo "<B>".$row[1]."</B>\n<BR>\n".$row[0];
				}
				if ($itemsPerPage != "") {
					if ($x == $itemsPerPage) {
						echo ("\n<DIV STYLE=\"page-break-before: always\">\n\n");
						$x = 0;
					}
					else {
						echo ("\n<P><BR>\n\n");
					}
				}
				else {
					echo ("\n<P><BR>\n\n");
				}
			}
		}
		if ($isCSV) {
			echo ("</PRE>\n");
		}
		mysql_free_result ($myresult);
		mysql_close ($db);
	}
}

/*
	This function converts the contents of a text file to a string and returns that string
*/
function fileToString($filename) {
	$fp = fopen($filename,'r');
	$string=fread($fp,filesize($filename));
	fclose($fp);
	return $string;
}


/*
	This function is used to retrieve get or post variables
*/
function getHTMLVariable (&$HTTP_GET_VARS, &$HTTP_POST_VARS, $varName) {
	if (!EMPTY($HTTP_POST_VARS[$varName])) {
		return $HTTP_POST_VARS[$varName];
	}
	else {
		return $HTTP_GET_VARS[$varName];
	}
}
?>
