<?php

# HTML Tree Class Object
class HTMLTree {


	# Class Variables
	var $db;
	var $connected;
	var $IMGURL;
	var $DIRIMG;
	var $ADIRIMG;
	var $ITEMIMG;
	var $AITEMIMG;
	var $TREEFONT;
	var $ATREEFONT;
	var $ITEMFONT;
	var $ERRORMSG;
	var $ROOTDIR;
	var $USER;
	var $ADIR;
	var $SEL;
	var $ID;
	var $SORTMETHOD;
	var $VIEWOPTION;
	var $BREAKPT;
	var $TEXTCOLOR;
	var $BORDERCOLOR;
	var $LIGHTCOLOR;
	var $DARKCOLOR;
	var $ERRORCOLOR;
	var $FILEDIR;
	var $RESTOREPREVSELECTION;
	var $BINITEMIMG;
	var $ABINITEMIMG;
	var $EMBEDCODE;
	var $APPURL;
	var $SESSION;
	var $showItems;


	# Object constructor
	# a = dbserver, b = db, c = dbuser, d = dbpswd, e = imgurl, f = dirimg, g = adirimg, h = itemimg, i = aitemimg
	# j = treefont, k = atreefont, l = itemfont, m = errmsg, n=include items in tree o = rootdir
	# p = createtables, q = user, r = selected directory, s = selected item, a2= copy or move item, t = sortmethod, u = viewoption
	# v = text color, w = border color,  x = light color, y = darkcolor z = items per column in list mode, a1 = create database?
	# a1 = create database, a2 = cpMv item id, a3 = error color, a4 = file directory (used to create files), a5 = html file directory (how browser accesses files)
	function HTMLTree ($a, $b, $c, $d, $e, $f, $g, $h, $i, $j, $k, $l, $m, $o, $p, $q, $r, $s, $a2, $t, $u, $sessionid, $kp3,$v, $w, $x, $y, $a3, $z, $a1, $a4, $a6, $BINITEMIMG, $ABINITEMIMG, $EMBEDCODE, $APPURL, $SESSION) {
		# Set Object variables
		$this->BINITEMIMG=$BINITEMIMG;
		$this->ABINITEMIMG=$ABINITEMIMG;
		$this->EMBEDCODE=$EMBEDCODE;
		$this->IMGURL = $e;
		$this->DIRIMG = $f;
		$this->ADIRIMG = $g;
		$this->ITEMIMG = $h;
		$this->AITEMIMG = $i;
		$this->TREEFONT = $j;
		$this->ATREEFONT = $k;
		$this->ITEMFONT = $l;
		$this->ERRORMSG = $m;
		$this->ROOTDIR = $o;
		$this->APPURL=$APPURL;
		$this->SESSION=$SESSION;
		$this->sessionid=$sessionid;
		$this->kp3=$kp3;
		
		if ($q) {
			$this->USER = strtolower($q);
		}
		else {
			$this->USER = "anonymous";
		}
		$this->FILEDIR = $a4;
			
		if ($r)
			$this->ADIR = $r;
		else
			$this->ADIR = $o;
			
		$this->ID=$a2;
			
		$this->SORTMETHOD = $t;
		$this->VIEWOPTION = $u;
		$this->BREAKPT = $z;
		$this->TEXTCOLOR = $v;
		$this->BORDERCOLOR = $w;
		$this->LIGHTCOLOR = $x;
		$this->DARKCOLOR = $y;
		$this->ERRORCOLOR = $a3;
		$this->RESTOREPREVSELECTION = $a6;

		# Connect to database server
		//$this->db = mysql_pconnect($a, $c, $d);
		
		//if ($a1)
		//	$this->createDatabase($b);
		
		# Connect to database
		//if ($this->db)
		//	$this->connected = mysql_select_db($b,$this->db);
			
		# Create Tables
		//if ($p)
		//	$this->createTables();
			
		//if (!$this->connected)
		//	echo($this->createErrorMSG("HTMLTree (60)", "Unable to connect to database"));
			
		if ($s && $s != "null") {
			$this->SEL = $s;
		}
		else {
			$this->SEL = $this->getFirstItem ($this->ADIR);
		}
		

	} # end function HTMLTree
	
	
	# This function destroys the object by closing database connection
	function destroy () {
		mysql_close ($this->db);
	}
	
	
	
	# This function creates an error message
	function createErrorMSG ($sFunction, $sMsg) {
		return ("<BR>".$this->ITEMFONT."\n<B>HTMLTree->".$sFunction."</B>\n<BR><FONT COLOR='".$this->ERRORCOLOR."'>Error: ".$sMsg."\n<P>\n\n<FONT COLOR='black'>".$this->ERRORMSG."</BODY></HTML>");
	}
	
	function check_perms($has, $needed)
	{
		return (!!($has & $needed) == True);
	}

	
	# This function returns the text associated with an item or topic id
	function getTreeText ($iOwner) {
		
		if ($iOwner || $iOwner == 0) {

			$text = "";
			
			# Create SQL
			if ($iOwner < 1000000)
				$sql = "SELECT sTopic FROM tblTopics WHERE iTopicID = ".$iOwner;
			else
				$sql = "SELECT sTitle FROM tblTopicItems WHERE iTopicItemID = ".$iOwner;
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("GetTreeText (293)", "Unable to run query"));		
			
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$text = $row[0];
			}
			else {
				//echo($this->createErrorMSG("GetTreeText (300)", "Unable to locate tree item"));
				$text = lang('select an item');
			}
			
			mysql_free_result ($myresult);
			return $text;
		}
		else
			echo($this->createErrorMSG("GetTreeText (118)", "Tree Item cannot be null"));
			
	} # end function GetTreeText
	
	
	# This function creates an html tree based on the root directory ($ROOTDIR) and selected
	# directory ($DIR)... if includeItems then items will also be shown
	function printTree ($includeItems, $CpMv) {
		
		global $cp_mv;
		$cp_mv = $CpMv;
		
		echo ("<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%><TR><TD VALIGN='bottom'>");
		$this->displayDir ($this->ROOTDIR, $includeItems);
		echo ("</TD></TR></TABLE>");
		
		$accesslevel = $this->accessLevel ($this->ADIR);

		if ($accesslevel >= 2 && $CpMv && $this->ID)
			$accesslevel = $this->accessLevel ($this->ID);

		# Show summary
		if ($accesslevel > 1) {
			$this->showDirSummary();
			// $this->displayViewOptions();
		}

		# Determine access level
		if ($accesslevel >= 2 && !$CpMv)
			$this->createTreeEditForms($this->ADIR, true);
		else if ($accesslevel >= 2 && $CpMv)
			$this->createTreeCpMvForm($this->ADIR, $CpMv);
			
		# Determine access level for the item
		if (!$CpMv) {
			$accessLevel = 0;
			if ($this->SEL > 1000000) {
				$accessLevel = $this->accessLevel ($this->SEL);
			}
				
			# Create item option
			if ($accessLevel >= 2)
				$this->createTreeEditForms($this->SEL, false);
		}
			
		# Create form to change the tree
		//echo ("<FORM NAME=\"changetree\" action=\"".$this->APPURL."\" METHOD=\"get\">\n");
		echo ("<FORM NAME=\"changetree\" METHOD=\"get\">\n");
		$this->standardFields($CpMv);
		echo ("</FORM>\n");
	}
	
	
	# This function shows the items based on the selected directory ($ADIR)
	# If includeDirs then child directories are also shown
	# Items are shown based on $SORTMETHOD and $VIEWOPTION
	function printItems ($dir, $includeDirs, $inTree) {
		if (!$dir)
			$dir = $this->ADIR;
	
		# Create Header if items do not appear in a tree
		if (!$inTree) {
			$this->displayViewOptions ();
			$this->createItemsHeader();
		}
	
		# Start list table if view option is List
		if ($this->VIEWOPTION==0 && !$inTree)
			echo ("<TABLE WIDTH=100% HEIGHT=100% CELLPADDING=0 CELLSPACING=2 VALIGN='top'><TR><TD VALIGN='top'>\n");	
	
		# Include Directories
		if ($includeDirs) {
			$this->listDirContents(true, $inTree, $this->BREAKPT, $dir);
		}
		
		# Items
		$this->listDirContents(false, $inTree, $this->BREAKPT, $dir);
		
		# Close list table
		if ($this->VIEWOPTION==0 && !$inTree)
			echo ("</TD></TR></TABLE>\n");				
	
		# Create Footer if items do not appear in a tree
		if (!$inTree)
			$this->createItemsFooter();	
	
	}
	
	
	# This function displays the selected item (if permissions allow for it)
	# Based on the selected item ($SEL)
	function printItem () {
		$text = "";
	
		# Determine access level
		if ($this->SEL > 1000000) {
			$text = $this->getItemText($this->SEL);
			$accessLevel = $this->accessLevel ($this->SEL);
			if (!($accessLevel > 0) && $text) {
				if ($this->accessLevel($this->ADIR)) {
					$text = lang('you are not authorized to view this item');
				}
				else {
					$text="";
				}
			}
		}
		echo ($this->ITEMFONT);
		
		# Determine if php code has been imbedded
		if (strstr($text, "<?") && $this->EMBEDCODE) {
			$this->inbedFile ($text);
		}
		else {
			if (strstr($text, "PHPTREEFILE")) {
				if ($this->SESSION) {
				    $href = $this->APPURL . "?";
				    } else {
				    $href = $this->APPURL . "&";
				    }
				    $lang_msg = lang('click here to download this file');
				echo ("<A HREF=\"$href");
				echo ("downloadFile=true&dir=$this->ADIR&sel=$this->SEL&id=$this->ID\">$lang_msg</A> (".$this->getFileSize ($this->SEL).")");
				//echo ("\n\n<SCRIPT LANGUAGE='Javascript'>\n");
				//echo ("	popup('?downloadFile=true&dir=$this->ADIR&sel=$this->SEL&id=$this->ID', 500, 700, false, true);\n");
				//echo ("</SCRIPT>\n");
			}
			else {
				echo ($text);
			}
		}
		
		echo ("</FONT>");
	}
	
	
	# This function is used to print the file type for binary files
	function printFileType () {
		if ($temp=$this->getBinFileElement("type", $this->SEL)) {
			$title = $this->getBinFileName($this->SEL);
			Header("Content-type: $temp");
			header("Content-Disposition: filename= " . $title );
		}
		else {
			Header("Content-type: text/plain");
		}
	}
	
	
	# This function is used to print the file contents for binary files
	function printFileData () {
		if ($temp=$this->getBinFileElement("data", $this->SEL)) {
			echo $temp;
		}
		else {
			echo lang('you are not authorized to view this document');
		}
	}
	
	
	# This function is used to print the file size for binary files
	function printFileSize () {
		if ($size=$this->getFileSize ($this->SEL)) {
			echo $size;
		}
		else {
			echo "0 KB";
		}
	}
	function getFileSize ($sel) {
		if ($temp=$this->getBinFileElement("size", $sel)) {
			$des="KB";
			$size=$temp/1000;
			if ($size>=1000) {
				$size/=1000;
				$des="MB";
			}
			if ($size>=1000) {
				$size/=1000;
				$des="GB";
			}
			return $size." ".$des;
		}
		else {
			return false;
		}
	}
	
	
	# This function prints a binary file element
	function getBinFileElement ($element, $sel) {
		$returnVal=false;
		# Determine access level
		if ($this->SEL > 1000000) {
			$accessLevel = $this->accessLevel ($sel);
			if ($accessLevel > 0) {
				$sql="SELECT $element FROM tblTopicItemFile WHERE iTopicItemID=$sel";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("printBinFileElement (519)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				if ($row = mysql_fetch_array ($myresult)) {
					$returnVal=$row[0];
				}
				mysql_free_result ($myresult);
			}
		}
		return $returnVal;
	}
	
	# This function prints a binary file name
	function getBinFileName ($sel) {
		$returnVal=false;
		# Determine access level
		if ($this->SEL > 1000000) {
			$accessLevel = $this->accessLevel ($sel);
			if ($accessLevel > 0) {
				$sql="SELECT sTitle  FROM tblTopicItems WHERE iTopicItemID=$sel";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("printBinFileElement (519)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				if ($row = mysql_fetch_array ($myresult)) {
					$returnVal=$row[0];
				}
				mysql_free_result ($myresult);
			}
		}
		return $returnVal;
	}
	
	# This function creates and inbeds a file into the html. It is used
	# when a file has imbedded php code
	function inbedFile ($text) {
		$fileName = $this->FILEDIR.chr(rand(97, 122)).chr(rand(97, 122)).chr(rand(97, 122)).chr(rand(97, 122)).".inc";
		
		$fp = fopen ($fileName, "w");
		fwrite ($fp, $text);
		fclose($fp);
		
		include ($fileName);
		
		unlink ($fileName);
	}
	
	
	# This function prints an item within a tree and determine if this item
	# should be expanded
	function displayDir ($dir, $showItems) {
		global $cp_mv;
		
		$this->showItems=$showItems;
		
		# Set expanded variable
		$isExpanded = false;

		# This item needs to be expanded
		if (($dir == $this->ADIR) || ($this->isChild($dir, $this->ADIR)))
			$isExpanded = true;
			
		# Print this item
		if ($isExpanded) {
			$image = $this->IMGURL.$this->ADIRIMG;
		} else {
			$image = $this->IMGURL.$this->DIRIMG;
		}
			
		if ($dir == $this->ADIR) {
			$font = $this->TREEFONT."<U>";
			$fontclose = "</U></FONT>";
		}
		else {
			$font = $this->TREEFONT;
			$fontclose = "</FONT>";
		}
			
		$treeText = $this->getTreeText($dir);
		$lineDown = "</TD></TR>\n<TR><TD VALIGN='bottom'>";

		if ($dir == $this->ROOTDIR) {
			$lineDown="";
		}

		// Added by Sam Przyswa
		$accessLevel = $this->accessLevel($dir);
		if ($accessLevel) {
		    echo ($lineDown."<NOBR>".$this->createIndent ($dir).$this->createItemURL ($dir, $treeText, $cp_mv).$this->createIMGURL ($dir, $isExpanded)."</A>".$this->createItemURL ($dir, $treeText, $cp_mv).$font.$treeText."</A>".$fontclose);
		
		# Print all children if this item is expanded
		if ($isExpanded) {
		
			if ($accessLevel) {
				$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$dir." ORDER BY sTopic ASC";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("displayDir (172)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
				while ($row = mysql_fetch_array ($myresult))
					$this->displayDir ($row[0], $showItems);
					
				mysql_free_result ($myresult);
			
				# Show items if specified
				if ($showItems)
					$this->printItems ($dir, false, true);
			}
			else {
				if ($dir=$this->ADIR) {
					$this->SEL="null";
				}
				$ri=false;
				if (!$this->hasChildren ($dir)) {
					$tcat="newitemform";
					$this->saveItem($tcat, $tid, "temp", "anonymous", "none", "---", "---","none","none","temp",$dir,$activeField, true);
					$ri=true;
				}
				echo ("</TD></TR>\n<TR><TD VALIGN='bottom'>".$this->createIndent ($this->getLastItem($dir)).$this->TREEFONT."<FONT COLOR='".$this->ERRORCOLOR."'>Access Denied</FONT>\n");
				if ($ri) {
					$this->deleteItem($tid);
				}
			}
		}
	    }
	}
	
	
	# This function determines if $parent is a parent item to $child
	function isChild ($parent, $child) {

		$parentid = $this->getParentID ($child);
		
		if ($parentid == "")
			echo($this->createErrorMSG("isChild (213)", "Unable to locate parent id"));
		
		# Parent Child relationship does exist
		if ($parentid == $parent)
			return true;
			
		# Parent Child relationship does not exist
		else {
			# Determine if this is the root directory
			if (($parentid == $this->$ROOTDIR) || ($parentid == "0"))
				return false;
			else {
				return $this->isChild ($parent, $parentid);
			}
			
		}
		
	}
	
		
	# This function determine the user access level to the specified element
	function accessLevel ($element) {
		$accessLevel = 0;

		// Added by Sam Przyswa
		global $group_names;
		$this->grants = $GLOBALS['phpgw']->acl->get_grants('phptree');
		$this->userID = $GLOBALS['phpgw_info']['user']['account_id'];

		$user_groups = $GLOBALS['phpgw']->accounts->membership();
		$group_names = Array();

		while (list ($key, $val) = each ($user_groups) ) {
		    $group_names[] = $val['account_name'];
		    }	
		reset($user_groups);
			
		$sql = "SELECT iOwner FROM tblOwner WHERE sUser='".$this->USER."' AND iOwner = ".$element;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("accessLevel (273)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

		# User is owner
		// Sam Przyswa
		
		if ((mysql_num_rows ($myresult) != 0) || (in_array("Admins", $group_names)))
			{
			$accessLevel = 8;
			}
		mysql_free_result ($myresult);

		# If user is not owner then determine access level
		if (!$accessLevel) {
			$sql = "SELECT iAccessLevel FROM tblPermissions WHERE iOwner = ".$element;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("accessLevel (284)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

			# Determine user access level
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$accessLevel = $row[0];
				// print("Access=$accessLevel");
			}
			mysql_free_result ($myresult);
		}
		
		# Determine if use is member of group with access
		if ($accessLevel ==1) {
		
			// Modif Sam Przyswa
			//
			//$sql = "SELECT g.iAccessLevel FROM tblGroupPermissions g, tblGroupMembers m WHERE m.sUser='".$this->USER."' AND g.iOwner = ".$element. " AND g.iGroupID = m.iGroupID";
			//$myresult = mysql_query ($sql)
			//	or die ($this->createErrorMSG("accessLevel (273)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			//# Group exists	
			
			//if (mysql_num_rows ($myresult) != 0) {
			//	$row = mysql_fetch_array ($myresult);
			//	$accessLevel = $row[0];
			//}
			//mysql_free_result ($myresult);
			
			$sql = "SELECT u.account_id FROM phpgw_accounts u, tblOwner e WHERE e.iOwner='".$element."' AND e.sUser = u.account_lid";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("accessLevel (273)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
			$row = mysql_fetch_array ($myresult);
			$owner_ID = $row[0];
				
			if ($this->check_perms($this->grants[$owner_ID],PHPGW_ACL_READ)) {
			    $accessLevel = 1;
			} else {
			    $accessLevel = 0;
			    }
			if ($this->check_perms($this->grants[$owner_ID],PHPGW_ACL_ADD)) {
			    $accessLevel = 2;
			} 
			if ($this->check_perms($this->grants[$owner_ID],PHPGW_ACL_EDIT)) {
			    $accessLevel = 4;
			} 
			if ($this->check_perms($this->grants[$owner_ID],PHPGW_ACL_DELETE)) {
			    $accessLevel = 8;
			}

		}
		
		// print("AccessLevel=$accessLevel<br>User=$owner_ID");
		return $accessLevel;
	}
	
	
	# This function creates a management console for the directory or item
	function createTreeEditForms($owner, $isDir) {
	
	
		if ($isDir) {
			$editformCat = "dirform";
			$delButtonText = lang('delete');
			$editButtonText = lang('edit');
			$copyButtonText = lang('copy');
			$moveButtonText = lang('move');
			$createButtonText = lang('create');
			$uploadButtonText = lang('upload');
			$id = $this->ADIR;
			$formName = "treeform";
			$functionName = "treeFunction";
			$optionsText  = lang('- edit directory:');
			$optionsText .= " <b>".$this->cleanStrPut($this->getTreeText($owner))."</b>";
			$confirm  = lang('are you sure you wish to delete the directory');
			$confirm .= " ".$this->cleanStrPut($this->getTreeText($owner))."?\\n";
			$confirm .= lang('all sub-items will also be deleted and cannot be restored!');
		}
		else {
			$editformCat = "itemform";
			$delButtonText = lang('delete');
			$editButtonText = lang('edit');
			$copyButtonText = lang('copy');
			$moveButtonText = lang('move');
			$id = $this->SEL;
			$formName = "itemform";
			$functionName = "itemFunction";
			$optionsText = lang('- edit item:');
			$optionsText .= " <b>".$this->cleanStrPut($this->getTreeText($owner))."</b>";
			$confirm  = lang('are you sure you wish to delete the item');
			$confirm .= " ".$this->cleanStrPut($this->getTreeText($owner))."?\\n";
			$confirm .= lang('the item will be deleted and cannot be restored!');
		}
		$accessLevel = $this->accessLevel($owner);
		echo ("\n\n<SCRIPT LANGUAGE='Javascript'>\n");
		echo ("function ".$functionName."(cat) {\n");
		echo ("	var winHeight;\n");		
		echo ("	document.".$formName.".cat.value=cat;\n");
		echo ("	if (cat=='delitem') {\n");
		echo ("		if (confirm('".$confirm."')) {\n");
		echo ("			document.".$formName.".sel.value=null;");
		echo ("			document.".$formName.".submit();\n");
		echo ("		}\n");
		echo ("	}\n");
		echo ("	else {\n\n");
		echo ("		if (cat=='newitemform' || cat=='itemform') {\n");
		echo ("			winHeight=380;\n");
		echo ("		}\n");		
		echo ("		else if (cat=='newdirform' || cat=='dirform') {\n");		
		echo ("			winHeight=150;\n");		
		echo ("		}\n");	
		echo ("		else {\n");
		echo ("			winHeight=400;\n");	
		echo ("		}\n");
		
		if ($this->SESSION) {
		    echo ("		var url='?".$this->urlEncodeStandardFields()."&delowner=".urlencode($owner)."&dirID=$this->ADIR&id=$id&cat=' + cat;\n");
		    } else {
		    echo ("		var url = '$this->APPURL&".$this->urlEncodeStandardFields()."&delowner=".urlencode($owner)."&dirID=$this->ADIR&id=$id&cat=' + cat;\n");
		    }
		    
		echo ("		popup(url, winHeight, 400, true, true);\n");
		echo ("	}\n");
		echo ("}\n");		
		echo ("</SCRIPT>\n");
		//echo ("\n<FORM NAME='".$formName."'  action=\"".$this->APPURL."\" METHOD='post'>\n");
		echo ("\n<FORM NAME='".$formName."' METHOD='post'>\n");
		$this->standardFields ("");
		echo ("<INPUT TYPE='hidden' NAME='delowner' VALUE='".$owner."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='dirID' VALUE='".$this->ADIR."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='id' VALUE='".$id."'>\n");	
		echo ("<TABLE CELLSPACING=1 WIDTH=350 CELLPADING=0 BORDER=0><TR>\n");
		echo ("<TD BGCOLOR='".$this->BORDERCOLOR."'>\n");		
		echo ("<TABLE CELLSPACING=0 WIDTH=350 CELLPADING=0 BORDER=0><TR>\n");	
		echo ("<TD BGCOLOR='".$this->DARKCOLOR."' WIDTH=350>\n");
		echo ($this->ATREEFONT.$optionsText."<BR>\n<TABLE CELLSPACING=1 CELLPADING=0 BORDER=0><TR>\n");
		echo ("<TD BGCOLOR='".$this->LIGHTCOLOR."'WIDTH=350><NOBR>\n");
		// echo ("<img src=\"../phptree/images/cp.gif\" ALT=\"Copier\">");
		if ($accessLevel >= 8) {
		    echo ("<INPUT TYPE='button' NAME='delButton' onClick='".$functionName."(\"delitem\")' VALUE='".$delButtonText."'>\n");
		}
		echo ("<INPUT TYPE='button' NAME='copyButton' onClick='".$functionName."(\"cp\")' VALUE='".$copyButtonText."'>\n");
		if ($accessLevel >= 8) {
		    echo ("<INPUT TYPE='button' NAME='moveButton' onClick='".$functionName."(\"mv\")' VALUE='".$moveButtonText."'>\n");
		}
		if ($accessLevel >= 4) {
    		    echo ("<INPUT TYPE='button' NAME='editButton' onClick='".$functionName."(\"".$editformCat."\")' VALUE='".$editButtonText."'>\n");
		}
		if ($accessLevel >= 2 && $isDir) {
			echo ("<INPUT TYPE='button' NAME='newButton' onClick='".$functionName."(\"newdirform\")' VALUE='".$createButtonText."'>\n");
			echo ("<INPUT TYPE='button' NAME='newButton' onClick='".$functionName."(\"newitemform\")' VALUE='".$uploadButtonText."'>\n");
		}
		echo ("</TD></TR></TABLE>\n</TD></TR></TABLE>\n</TD></TR></TABLE>");
		echo ("</FORM>\n");
	}
	
	
	# This function creates a copy or move console for the directory or item
	function createTreeCpMvForm($owner, $CpMv) {
	
		
		// Check that all necessary data exists
		if ($this->ADIR && $this->ID && $CpMv) {
		
			if ($this->ID < 1000000)
				$item = lang('directory');
			else
				$item = lang('item');
		
			// Copy form
			if ($CpMv == "cp") {
				$confirmText = lang('- copy');
			}
			else if ($CpMv == "mv") {
				$confirmText = lang('- move');
			}
			$confirm  = lang('you are about to');
			$confirm .= " ".$confirmText." ";
			$confirm .= lang('the');
			$confirm .= " ".$item.": \\n\\n".$this->cleanStrPut($this->getTreeText($this->ID))."\\n\\n";
			$confirm .= lang('into the directory:');
			$confirm .= " \\n\\n".$this->cleanStrPut($this->getTreeText($this->ADIR))."\\n\\n";
			$confirm .= lang('Do you wish to continue?');
		
			echo ("\n\n<SCRIPT LANGUAGE='Javascript'>\n");
			echo ("function cpMvConfirm () {\n");
			echo ("	if (confirm('".$confirm."')) {\n");
			echo ("		document.forms.cpMv.submit();\n");
			echo ("	}\n");
			echo ("}\n");		
			echo ("</SCRIPT>\n");
			// echo ("\n\n<P><FORM NAME=\"cpMv\" action=\"".$this->APPURL."\" METHOD=\"post\">\n");
			echo ("\n\n<P><FORM NAME=\"cpMv\" METHOD=\"post\">\n");
			echo ("<INPUT TYPE='hidden' NAME='dirID' VALUE='".$this->ADIR."'>\n");
			echo ("<INPUT TYPE='hidden' NAME='isCpMvConfirmed' VALUE='true'>\n");
			$this->standardFields ($CpMv);
			echo ("<P>\n");
			echo ("<INPUT TYPE='button' NAME='cpMvButton' onClick='cpMvConfirm ()' VALUE='".ucfirst($confirmText)."'>\n");
			echo ("<INPUT TYPE='button' NAME='Cancel' onClick='window.close();' VALUE='Cancel'>\n<BR>");
			echo lang('new name');
			echo (" <FONT COLOR='".$this->DARKCOLOR."' STYLE='font-size: 10px;'>");
			echo lang('(not required):');
			echo ("<BR></FONT><INPUT TYPE='text' NAME='newName' SIZE=20><BR>\n");
			echo ("</FORM>\n");
		
		}
	}
	
	
	# This function deletes the specified directory or item
	function deleteTreeElement ($owner) {
		
		# Determine if user has access to delete this element
		
		# User has access
		if ($this->accessLevel ($owner) >= 4) {
			# Determine parent if this is a directory and set that to be the current active dir
			if ($owner < 1000000)
				$this->ADIR = $this->getParentID ($owner);
			else
				$this->SEL = $this->getFirstItem ($this->ADIR);
				
			# Directory
			if ($owner < 1000000) {
				$this->deleteDir($owner);
			}
			# Directory item
			else {
				$this->deleteItem($owner);
			}
		}
		# User does not have access
		else
			echo ($this->createErrorMSG ("deleteTreeElement (312)", "You do not have access to delete this tree element"));
	
	}
	
	
	# This function returns the parent id for this item
	function getParentID ($child) {
		if ($child) {
			if ($child < 1000000)
				$sql = "SELECT iParentID FROM tblTopics WHERE iTopicID=".$child;
			else
				$sql = "SELECT iTopicID FROM tblTopicItems WHERE iTopicItemID=".$child;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getParentID (308)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$parentid = $row[0];
			}
			mysql_free_result ($myresult);
			return $parentid;
		}
	}
	
	
	# This function deletes a tree element's properties
	function deleteProperties($owner) {
		# Ownership
		$sql = "DELETE FROM tblOwner WHERE iOwner = ".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteProperties (332)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	

		# Modifications	
		$sql = "DELETE FROM tblModified WHERE iOwner = ".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteProperties (337)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));		
	
		# Permissions
		$sql = "DELETE FROM tblPermissions WHERE iOwner = ".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteProperties (342)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		$sql = "DELETE FROM tblGroupPermissions WHERE iOwner = ".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteProperties (342)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));					
	
	}
	
	
	# This function deletes a tree item
	function deleteItem($owner) {	
		$sql = "DELETE FROM tblTopicItems WHERE iTopicItemID = ".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteItem (347)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		$sql = "DELETE FROM tblTopicItemFile WHERE iTopicItemID=$owner";
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteItem (853)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
		$this->deleteProperties($owner);
	
	}
	
	
	# This function deletes a directory's items
	function deleteDirItems($dir) {
		$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID = ".$dir;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("deleteDirItems (399)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
	
		while ($row = mysql_fetch_array ($myresult))
			$this->deleteItem ($row[0]);
			
		mysql_free_result ($myresult);	
	
	}
	
	
	# This function deletes an entire chain of directories beginning with the $dir dir
	function deleteDir($dir) {
		# Root directory cannot be deleted
		if ($dir == $this->ROOTDIR)
			echo $this->createErrorMSG("deleteDir (521)", "You cannot delete the root directory!");
			
		else {
			# Delete Children
			$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID = ".$dir;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("deleteDir (381)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
		
			while ($row = mysql_fetch_array ($myresult))
				$this->deleteDir ($row[0]);
			
			mysql_free_result ($myresult);
			
			# Delete this dir and items
			$sql = "DELETE FROM tblTopics WHERE iTopicID = ".$dir;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("deleteDir (392)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			$this->deleteDirItems($dir);
			$this->deleteProperties($dir);
		}
		
		
		
	}
	
	
	# This function returns the text corresponding to an item
	function getItemText($item) {
		$sql = "SELECT sTopicItem FROM tblTopicItems WHERE iTopicItemID = ".$item;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getItemText (409)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
	
		if (mysql_num_rows ($myresult) != 0) {
			$row = mysql_fetch_array ($myresult);
			$text = $row[0];
		}
		mysql_free_result ($myresult);
		return $text;
	
	}
	function getItemName($item) {
		$sql = "SELECT sTitle FROM tblTopicItems WHERE iTopicItemID = ".$item;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getItemText (409)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
	
		if (mysql_num_rows ($myresult) != 0) {
			$row = mysql_fetch_array ($myresult);
			$text = $row[0];
		}
		mysql_free_result ($myresult);
		return $text;
	
	}
	
	
	# This function returns the properties pertaining to the tree element
	function getProperties($owner, &$name, &$user, &$dtLastModified, &$lmUser, &$accessLevel, &$accessLevelDesc, &$group, &$groupAccess, &$groupAccessDesc) {
			
			if ($owner < 1000000) {
				$field = "t.iTopicID";
				$field1 = "t.sTopic";
				$table = "tblTopics t";
			}
			else {
				$field = "t.iTopicItemID";
				$field1 = "t.sTitle";
				$table = "tblTopicItems t";
			}
				
			$sql = "SELECT ".$field1.", o.sUser, p.iAccessLevel, d.sDescription ";
			$sql = $sql."FROM ".$table.", tblOwner o, tblPermissions p, tblPermissionDescriptions d ";
			$sql = $sql."WHERE ".$field."=".$owner." AND ".$field." = o.iOwner ";
			$sql = $sql."AND ".$field." = p.iOwner AND p.iAccessLevel = d.iAccessLevel";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getProperties (451)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
		
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$name = $row[0];
				$user = $row[1];
				$accessLevel = $row[2];
				$accessLevelDesc = $row[3];
				    
			}
			else
				echo ($this->createErrorMSG ("getProperties (463)", "Unable to retrieve item properties<BR><PRE>".$sql."</PRE>"));
			mysql_free_result ($myresult);
			
			
			# Determine group permission information
			$sql = "SELECT p.iAccessLevel, d.sDescription, g.sGroupName FROM tblGroupPermissions p, tblPermissionDescriptions d, tblGroups g ";
			$sql = $sql."WHERE p.iOwner=".$owner." AND p.iGroupID = g.iGroupID AND p.iAccessLevel = d.iAccessLevel ";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getProperties (535)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
		
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$group = $row[2];
				$groupAccess = $row[0];
				$groupAccessDesc = $row[1];
				
			}
			# No group permissions exist
			else {
				$group = "none";
				$groupAccess = 0;
				$groupAccessDesc = "--";
			}

			
			# Determine last modification information
			$sql = "SELECT MAX(dtLastModified) FROM tblModified WHERE iOwner=".$owner." GROUP BY iOwner";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getProperties (469)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
		
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$dtLastModified = $row[0];
				$lmUser = $row[1];
			}
			else
				echo ($this->createErrorMSG ("getProperties (479)", "Unable to retrieve item properties"));
			mysql_free_result ($myresult);
			
			$sql = "SELECT sUser FROM tblModified WHERE iOwner=".$owner." AND dtLastModified='".$dtLastModified."'";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getProperties (482)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));	
		
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$lmUser = $row[0];
			}
			else
				echo ($this->createErrorMSG ("getProperties (489)", "Unable to retrieve item properties"));
			mysql_free_result ($myresult);			
	
	}
	
	
	# This function creates an appropriate header for displaying items based on the selected view options
	function createItemsHeader() {
		# Detailed Option
		if ($this->VIEWOPTION != 0) {
			echo ("<TABLE CELLSPACING=0 CELLPADING=0 BORDER=0 WIDTH=100%><TR>\n");
			echo ("<TR><TD BGCOLOR='".$this->BORDERCOLOR."'>\n<TABLE CELLSPACING=1 CELLPADING=2 BORDER=0 WIDTH=100%><TR>\n");
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Type/Access</B></FONT></NOBR></TD>\n");
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Count</B></FONT></NOBR></TD>\n");						
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Owner</B></FONT></NOBR></TD>\n");
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Group</B></FONT></NOBR></TD>\n");			
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Last Modified</B></FONT></NOBR></TD>\n");
			echo ("<TD BGCOLOR='".$this->DARKCOLOR."'>".$this->ATREEFONT."<NOBR><B>&nbsp;Item</B></FONT></NOBR></TD>\n");			
			echo ("</TR>");
		}
	
	}
	
	
	# This function creates an appropriate footer for displaying items based on the selected view options
	function createItemsFooter() {
		# Detailed Option
		if ($this->VIEWOPTION != 0)
			echo ("</TD></TR></TABLE></TABLE>");
	
	}
	
	
	# This function displays an item based on the selected view options
	function printSingleItem($dir, $id, $name, $owner, $permissions, $dtLastModified, $lmuser, $inTree, $group, $groupAccessDesc) {
		global $cp_mv;
		# Create font
		$isExpanded = false;
		$font = $this->TREEFONT;
		$fontclose = "</FONT>";		
		
		if (!$dir && $id == $this->SEL) {
			$font = $this->ATREEFONT."&nbsp;";
			$fontclose = "&nbsp;</FONT>";
		}

		if ($inTree)
			$indent = $this->createIndent($id);
		else
			$indent = "&nbsp;&nbsp;&nbsp;";
		
		# File
		if ($dir) {
			if ($id == $this->ADIR)
				$isExpanded = true;
			$start = "d";
			$numSub = $this->countSubDirs($id) + $this->countSubItems($id);
			$ref = $indent.$this->createItemURL ($id, $name, $cp_mv).$this->createIMGURL ($id, $isExpanded)."</A><NOBR>".$this->createItemURL ($id, $name, $cp_mv).$font."&nbsp;".$name.$fontclose."</A>";
		}
		# Item
		else {
			if ($id == $this->SEL)
				$isExpanded = true;		
			$start = "-";
			$numSub = "1";
			$ref = $indent.$this->createItemURL ($id, $name, $cp_mv).$this->createIMGURL ($id, $isExpanded)."</A><NOBR>".$this->createItemURL ($id, $name, $cp_mv).$font.$name.$fontclose."</A>";
		}
		
		$itempermissions = $start.$groupAccessDesc.$permissions;
		
		# Detailed Option
		if (($this->VIEWOPTION != 0) && (!$inTree)) {
			echo ("<TR>\n");
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'><NOBR>".$this->TREEFONT.$itempermissions."</FONT></NOBR></TD>\n");			
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'><NOBR>".$this->TREEFONT.$numSub."</FONT></NOBR></TD>\n");
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'><NOBR>".$this->TREEFONT.$owner."</FONT></NOBR></TD>\n");
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'><NOBR>".$this->TREEFONT.$group."</FONT></NOBR></TD>\n");
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'><NOBR>".$this->TREEFONT.$dtLastModified.">".$lmuser."</FONT></NOBR></TD>\n");
			echo ("<TD VALIGN='top' ALIGN='left' BGCOLOR='#ffffff'>".$this->TREEFONT.$ref."</FONT></NOBR></TD>\n");			
			echo ("</TR>");
		}
		else
			echo ("</TD></TR>\n<TR><TD VALIGN='bottom'>".$ref);
			
	}
	
	
	# This function lists the contents of the currently selected directorys based on the selected sort method
	function listDirContents ($dir, $inTree, $breakPt, $id) {

		global $group_names;
		
		# Determine sort method
		
		# Sort by date
		if ($this->SORTMETHOD == 3) {
			if ($dir) {
				$sql = "SELECT t.iTopicID FROM tblTopics t, tblModified m ";
				$sql = $sql."WHERE t.iParentID=".$id." AND t.iTopicID = m.iOwner ";
				$sql = $sql."GROUP BY t.iTopicID ORDER BY m.dtLastModified DESC";
			}
			else {
				$sql = "SELECT t.iTopicItemID FROM tblTopicItems t, tblModified m ";
				$sql = $sql."WHERE t.iTopicID=".$id." AND t.iTopicItemID = m.iOwner ";
				$sql = $sql."GROUP BY t.iTopicItemID ORDER BY m.dtLastModified DESC";
			}
			
		}
		else {
			if ($dir)
				$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$id." ORDER BY sTopic ASC";
			else
				$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID=".$id." ORDER BY sTitle ASC";
		
		}
	
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("listDirContents (686)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

		$x = 0;
		while ($row = mysql_fetch_array ($myresult)) {
			$this->getProperties($row[0], $name, $user, $dtLastModified, $lmuser, $accessLevel, $accessLevelDesc, $group, $groupAccess, $groupAccessDesc);

			// Added by Sam Przyswa
			// Don't show it if accesLevelDesc is "---" or accessLevel is 0
			if (($accessLevelDesc != "---") || ($this->USER == $user) || (in_array("Admins", $group_names))) { 
			    $this->printSingleItem($dir, $row[0], $name, $user, $accessLevelDesc, $dtLastModified, $lmuser, $inTree, $group, $groupAccessDesc);
			    }
			if ($this->VIEWOPTION==0 && !$inTree && $x == $breakPt) {
				echo ("</TD>\n<TD VALIGN='top'>\n");
				$x = -1;
			}
			$x = $x + 1;
		}
		mysql_free_result ($myresult);
		
	}
	
	
	# This function determine summary information for the selected directory
	function showDirSummary () {
	
		$dirs = $this->countSubDirs ($this->ADIR);
		$items = $this->countSubItems ($this->ADIR);
		
		# Titles
		if ($dirs == 1)
			$dirtitle = " Directory";
		else
			$dirtitle = " Directories";
			
		if ($items == 1)
			$itemtitle = " Item";
		else
			$itemtitle = " Items";
			
		# Display summary
		// echo ("<P>".$this->TREEFONT.$dirs.$dirtitle."<BR>".$items.$itemtitle);
	
	}
	
	
	# This function creates the form necessary to change the sort method and view options
	function displayViewOptions () {
		// echo ("<FORM NAME='viewoptions'  action=\"".$this->APPURL."\" METHOD='post'>\n");
		echo ("<FORM NAME='viewoptions' METHOD='post'>\n");
		$this->standardFields ("");
		echo ("<TABLE CELLSPACING=0 CELLPADING=0 BORDER=0 WIDTH=100%><TR>\n");
		echo ("<TR><TD BGCOLOR='".$this->BORDERCOLOR."'>\n<TABLE CELLSPACING=1 CELLPADING=2 BORDER=0 WIDTH=100%><TR><TD WIDTH=50% BGCOLOR='".$this->DARKCOLOR."'><NOBR>\n");
		echo ($this->ATREEFONT."&nbsp;Sort: ");
		$sel = "";
		if ($this->SORTMETHOD == 0)
			$sel = " CHECKED";
		echo ("<INPUT TYPE='radio' NAME='sortmethod' VALUE='0' onClick='document.viewoptions.submit()'".$sel.">By Name\n");
		$sel = "";
		if ($this->SORTMETHOD == 3)
			$sel = " CHECKED";
		echo ("<INPUT TYPE='radio' NAME='sortmethod' VALUE='3' onClick='document.viewoptions.submit()'".$sel.">By Date\n");
		$sel = "";
		if ($this->VIEWOPTION == 0)
			$sel = " CHECKED";
		echo ("</NOBR></TD><TD WIDTH=50% BGCOLOR='".$this->DARKCOLOR."'><NOBR>");
		echo ($this->ATREEFONT."&nbsp;View: ");		
		echo ("<INPUT TYPE='radio' NAME='viewoption' VALUE='0' onClick='document.viewoptions.submit()'".$sel.">List\n");
		$sel = "";
		if ($this->VIEWOPTION == 1)
			$sel = " CHECKED";
		echo ("<INPUT TYPE='radio' NAME='viewoption' VALUE='1' onClick='document.viewoptions.submit()'".$sel.">Details\n");
		echo ("</NOBR></TD></TR></TABLE></TD></TR></TABLE>");
		echo ("</FORM>\n");	
	
	}
	
	
	# This function creates standard hidden input fields
	function standardFields ($CpMv) {
		//global $cp_mv;
		//$cp_mv = $CpMv;
		
		echo ("<INPUT TYPE='hidden' NAME='dir' VALUE='".$this->ADIR."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='sel' VALUE='".$this->SEL."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='sortmethod' VALUE='".$this->SORTMETHOD."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='viewoption' VALUE='".$this->VIEWOPTION."'>\n");
		echo ("<INPUT TYPE='hidden' NAME='cat' VALUE='".$CpMv."'>\n");
		if ($this->sessionid) {
			echo ("<INPUT TYPE='hidden' NAME='sessionid' VALUE='".$this->sessionid."'>\n");
			echo ("<INPUT TYPE='hidden' NAME='kp3' VALUE='".$this->kp3."'>\n");
			}
		if ($this->ID) {
			echo ("<INPUT TYPE='hidden' NAME='id' VALUE='".$this->ID."'>\n");
			}
	}
	function urlEncodeStandardFields () {
		$returnval = "dir=$this->ADIR&sel=$this->SEL&sortmethod=".urlencode($this->SORTMETHOD)."&viewoption=".urlencode($this->VIEWOPTION);
		if ($this->ID)
			$returnval.="&id=$this->ID";
		return $returnval;
	}
	
	
	# This function counts the number of sub directories a directory has
	function countSubDirs ($dir) {
		# Number of directories
		$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$dir;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("showDirSummary (618)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));		
		$dirs = mysql_num_rows ($myresult);
		mysql_free_result ($myresult);
		
		return $dirs;	
	
	}
	
	
	# This function counts the number of sub items a directory has
	function countSubItems ($dir) {
		# Number of items
		$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID=".$dir;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("showDirSummary (618)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));		
		$items = mysql_num_rows ($myresult);
		mysql_free_result ($myresult);
		
		return $items;
	
	}
	
	
	# This function returns the url for the correct image for the item passed
	function createIMGURL ($owner, $isActive) {
		if ($owner > 1000000) {
			$text=$this->getItemText($owner);
			if (strstr($text, "PHPTREEFILE")) {
				$name=explode(".", $this->getItemName($owner));
				$ext=$name[count($name)-1];
				if (file_exists(strtolower($this->IMGURL.$ext.".gif"))) {
					$img = $ext.".gif";
				}
				else {
					$img = $this->BINITEMIMG;
				}
			}
			else {
				$img = $this->ITEMIMG;
			}
		}
		else
			$img = $this->DIRIMG;
	
		if ($isActive) {
			if ($ext && $img != $this->BINITEMIMG) {
				if (file_exists(strtolower($this->IMGURL."a".$ext.".gif"))) {
					$img = "a".$img;
				}
			}
			else {
				$img = "a".$img;
			}
		}
	
		return ("<IMG SRC='".$this->IMGURL.$img."' ALIGN='left' VSPACE=0 HSPACE=0 BORDER=0>");
		
	}	
	
	
	# This function stores the current user selection to the database
	function storeUserSelection () {
		$val1 = 0;
		$val2 = 0;
		$val3 = 0;
		$val4 = 0;
		$val0 = 'none';
		if ($this->ADIR)
			$val1 = $this->ADIR;
		if ($this->SEL)
			$val2 = $this->SEL;
		if ($this->SORTMETHOD)
			$val3 = $this->SORTMETHOD;
		if ($this->VIEWOPTION)
			$val4 = $this->VIEWOPTION;
		if ($this->USER)
			$val0 = $this->USER;
		$sql = "DELETE FROM tblUserSelection WHERE sUser='".$val0."' AND iRootDir=$this->ROOTDIR";
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("storeUserSelection (866)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));		
		$sql = "INSERT INTO tblUserSelection VALUES ('".$val0."',$this->ROOTDIR,".$val1.",".$val2.",".$val3.",".$val4.")";
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("storeUserSelection (869)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
	}
	
	
	# This function restores a previous user selection from the database
	function restoreUserSelection () {
		if ($this->RESTOREPREVSELECTION) {
			$user='none';
			if ($this->USER)
				$user = $this->USER;
				
			$sql = "SELECT * FROM tblUserSelection WHERE sUser='".$user."' AND iRootDir=$this->ROOTDIR";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("restoreUserSelection (882)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				if ($row[2])
					$this->ADIR = $row[2];
				if ($row[3])
					$this->SEL = $row[3];			
				if ($row[4])
					$this->SORTMETHOD = $row[4];
				if ($row[5])			
					$this->VIEWOPTION = $row[5];
			}
		}
	}
	
	
	# Function used to retrieve an objects keywords is CSV format
	function getKeywords ($owner) {
		$keywords = "";
		$sql = "SELECT sKeyword FROM tblKeywords WHERE iOwner=".$owner;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getKeywords (906)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

		while ($row = mysql_fetch_array ($myresult)) {
			if ($keywords)
				$keywords = $keywords.", ".$row[0];
			else
				$keywords = $row[0];
		}
		mysql_free_result ($myresult);
		
		if ($keywords)
			return $keywords;
		else
			return "none";
		
	}
	
	
	# This function creates the form used to create or edit objects within the HTML tree
	function printObjectForm ($cat,$id,$name1,$owner1,$group1,$groupAccess1,$newGroup,$privateGroup,$newGroupMembers,$worldAccess1,$keywords,$updateReason,$itemText,$actn,$confirmActn,$dirID,$htmlOptions,$itemFile,$itemFile_name,$itemFile_type,$itemFile_size,$binary) {
		global $group_names;
			
		# Active field
		$activeField = "name";
		
		# Add Binary File
		if (is_uploaded_file($itemFile) && !$confirmActn && $binary=="true") {
			if (!$name1) {
				$name1=$itemFile_name;
			}
			$itemText="<PHPTREEFILE>";
			$confirmActn="true";
		}
		
		# Binary files
		if ($id) {
			if ($this->getFileSize ($id)) {
				$itemText="<PHPTREEFILE>";
			}
		}
	
		# Reset
		if ($actn == "reset" && $confirmActn) {
			$name1 = "";
			$owner1 = "";
			$group1 = "";
			$groupAccess1 = "";
			$worldAccess1 = "";
			$keywords = "";
			$updateReason = "";
			$itemText = "";
		}
		# Make Group
		if ($actn == "mkgrp") {
			$error = ($this->addGroup($newGroup,$newGroupMembers,$privateGroup,$activeField));
			if (!$error) {
				$group1 = $newGroup;
				$newGroup="";
				$newGroupMembers="";
				$privateGroup="";
			}
		}
		# Remove Group
		if ($actn == "rmgrp" && $confirmActn) {
			$error = ($this->removeGroup($group1));
			if ($error)
				$activeField = "group";
			else
				$group1 = "";
		}
		# Remove Group
		if ($actn == "rmgrp" && !$confirmActn && $group1 == "none") {
			$error = "You must select a group to remove.";
			$activeField = "group";
			$actn = "";
		}
		# Abort
		if ($actn == "abort" && $confirmActn) {
				$this->closeWindow($id);
		}
		# Save
		# if ($actn == "save" && $confirmActn) {
		#	$error = $this->saveItem($cat, $id, $name1, $owner1, $group1, $groupAccess1, $worldAccess1,$keywords,$updateReason,$itemText,$dirID,$activeField,false);
		# }
		# Check In
		if ($actn == "checkin" && $confirmActn) {
			if (!$updateReason) {
				$updateReason="none";
			}
			if ($updateReason || !$id) {
				if (!$updateReason)
					$updateReason="Document Created";
				$error = $this->saveItem($cat, $id, $name1, $owner1, $group1, $groupAccess1, $worldAccess1,$keywords,$updateReason,$itemText,$dirID,$activeField,false);
				if (!$error && $id) {
					# Add binary file
					if (is_uploaded_file($itemFile) && $binary=="true") {
						$sql = "DELETE FROM tblTopicItemFile WHERE iTopicItemID=$id";
						$myresult = mysql_query ($sql)
							or die ($this->createErrorMSG("printObjectForm (1385)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
							
						$dta = addslashes(fread(fopen($itemFile, "r"), filesize($itemFile)));
						$sql = "INSERT INTO tblTopicItemFile (iTopicItemID, type, size, data) VALUES ($id, '$itemFile_type', '$itemFile_size', '$dta' )";
						$myresult = mysql_query ($sql)
							or die ($this->createErrorMSG("printObjectForm (1389)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
					}
					$this->closeWindow($id);
				}
			}
			else {
				$error = "You must specify a Checkout reason when checking in a file.";
				$activeField = "updateReason";
			}
		}
		
		
		# Create popup error message
		if ($error)
			$this->createAlert($error);
		
		
		$isItem = false;
		$dir = false;
		
		if ($cat == "newdirform" || $cat == "dirform")
			$dir = true;
			
		$myText = $itemText;
		if ($id && $cat == "itemform") {
			# Determine contents of tree item
			$isItem = true;
			if ($itemText) {
				$myText = $itemText;
			}
			else if ($isItem) { 
				$myText =  $this->getItemText ($id); 
			}
		}
		
		if ($id) {
			$this->getProperties ($id, $name, $owner, $dtLastModified, $lmUser, $worldAccessNum, $worldAccess, $group, $groupAccessNum, $groupAccess);
			if (!$keywords) 
				$keywords = $this->getKeywords ($id);
			if ($addRevision || !$dir) {
				$addRevision = "CHECKED";
			}
			$ciText = "Revision Reason<BR><FONT COLOR='".$this->DARKCOLOR."' STYLE='font-size: 10px;'>(Required with new Revision):<BR></FONT></FONT>";
			$ciText .= "<INPUT TYPE='text' SIZE=20 NAME='updateReason' VALUE='".$updateReason."'>";
			$ciText .= $this->TREEFONT."<BR><INPUT TYPE='checkbox' NAME='addRevision' ".$addRevision.">Add Revision on Check-In";
		}
		else
			$ciText = "&nbsp;";
		
		# Test which variables are being passed (ie. when the form fails due to errors)
		if ($name1)
			$name = $name1;
		if ($owner1)
			$owner = $owner1;
		if ($worldAccess1)
			$worldAccess = $worldAccess1;
		if ($group1)
			$group = $group1;
		if ($groupAccess1)
			$groupAccess = $groupAccess1;

		?>
	<SCRIPT LANGUAGE="Javascript">
		function changeItem1 (actn) {
			document.changeItem.actn.value=actn;
			document.forms.changeItem.submit();
		}		
	</SCRIPT>
		<FORM ENCTYPE="multipart/form-data" METHOD="post" NAME="changeItem">
		<INPUT TYPE="hidden" NAME="cat" VALUE="<? echo ($cat); ?>">
		<INPUT TYPE="hidden" NAME="id" VALUE="<? echo ($id); ?>">
		<INPUT TYPE="hidden" NAME="dirID" VALUE="<? echo ($dirID); ?>">	
		<INPUT TYPE="hidden" NAME="owner" VALUE="<? echo ($this->USER); ?>">
		<TABLE CELLSPACING=1 CELLPADING=2 BORDER=0 WIDTH=100% ALIGN='left'>
		<? 
		if ($error) { 
		?>
			<TR>
				<TD VALIGN="top" BGCOLOR="#FFFFFF" COLSPAN=2>
					<? echo ($this->TREEFONT."<FONT COLOR='".$this->ERRORCOLOR."'>".$error); ?>
				</TD>				
			</TR>		
		<? } ?>
			<TR>
				<TD VALIGN="bottom" BGCOLOR="#FFFFFF" WIDTH=50%>
				<? 
				$this->createFontTag($error,$activeField,"name");
				echo lang('name:');
				 ?>

				</FONT><INPUT TYPE="text" SIZE=19 NAME="name" VALUE="<? echo ($name); ?>">				
				</TD>							
				<TD VALIGN="bottom" BGCOLOR="#FFFFFF" WIDTH=50%>
				<? $this->createFontTag($error,$activeField,"owner");
				
				$sql_a = array (
				    "SELECT sUser FROM tblOwner GROUP BY sUser ORDER BY sUser ASC",
				    "SELECT m.sUser FROM tblGroupMembers m, tblGroups g WHERE g.sUser = '".$this->USER."' OR g.sUser IS null AND g.iGroupID = m.iGroupID"
				);
				
				echo lang('owner:');
				// Added by Sam Przyswa
				if (in_array("Admins", $group_names)) {
				    print("</FONT>\n"); 
				    $this->createSelect($sql_a, "owner", $owner, 1, $this->USER, "");
				    } else {
				    print("<b>$owner</b></FONT>\n");
				    } 
				reset($group_names);    
				?>
				</TD>				
			</TR>
			

			<TR>
				<TD VALIGN="top" BGCOLOR="#FFFFFF" COLSPAN=2>
				<? 
				$this->createFontTag($error,$activeField,"worldAccess");
				echo lang('world access:');
				echo ("</FONT>");
				
				if (!$worldAccess) { 
				    $worldAccess="--r";
				    }

				echo ("<SELECT NAME=\"worldAccess\" SIZE=1>\n");
				// $this->createSelect($sql_a, "worldAccess", $worldAccess, 1, "", ""); 
    				$sql = "SELECT sDescription FROM tblPermissionDescriptions ORDER BY iAccessLevel";
				$sql_a = array($sql);
				for($x=sizeof($sql_a)-1; $x >=0; $x--) {
				    $sql = $sql_a[$x];
				    $myresult = mysql_query ($sql)
					    or die ($this->createErrorMSG("createSelect (1549)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

					    while ($row = mysql_fetch_array($myresult)) {
						$accessName = lang($row[0]);
						if ($worldAccess == $row[0]) {
						    echo ("<OPTION VALUE='$row[0]' SELECTED>".$accessName."</OPTION>");
						    } else {
						    echo ("<OPTION VALUE='$row[0]'>".$accessName."</OPTION>");
						    }
					    }
					mysql_free_result ($myresult);
				}
				echo ("</SELECT>\n");
				?>
				</TD>
			</TR>
			<!--
			<TR>
				<TD VALIGN="top" BGCOLOR="#FFFFFF" WIDTH=50%>
				<? $this->createFontTag($error,$activeField,"updateReason"); ?>
				<? echo $ciText; ?>
				</TD>							
			</TR>
			-->
			<?
			# Item form
			if (!$dir) {
			?>
			<TR>
				<TD VALIGN="top" BGCOLOR="#FFFFFF" WIDTH=50% COLSPAN=2>
				<? $this->createFontTag($error,$activeField,"itemText"); ?>
				<?
				$binary = "true"; // Sam Przyswa
				
				if (strstr($myText, "PHPTREEFILE")) {
					$myText= lang('TO UPDATE THIS FILE YOU MUST RE-UPLOAD IT');
				}
				echo lang('item text:');
				?>
				<BR></FONT><TEXTAREA NAME="itemText" COLS=40 ROWS=8 WRAP><? echo $this->cleanStrGet($myText); ?></TEXTAREA><BR>
				<? 
				$this->createFontTag($error,$activeField,"itemText"); 
				echo lang('file:');
				?>
				<FONT COLOR="<? echo $this->DARKCOLOR ?>" STYLE="font-size: 10px;">
				<INPUT TYPE="file" NAME="itemFile"><BR>
				<? 
				$this->createFontTag($error,$activeField,"itemText"); 
				echo lang('file type');
				?>
				<SELECT NAME="binary" SIZE=1>
				<?
				if (!$binary) {
					if (strpos(" $myText", "UPDATE THIS FILE YOU MUST")) {
						$binary="true";
					}
				}
				?>
				<OPTION VALUE="false"<? if ($binary=="false") { echo " SELECTED"; } ?>><? echo lang('text or html (text only)'); ?></OPTION>
				<OPTION VALUE="true"<? if ($binary=="true") { echo " SELECTED"; } ?>><? echo lang('downloadable (binary or text)'); ?></OPTION>
				</SELECT><BR>
				<? echo lang('html options:'); ?>
				<SELECT NAME="htmlOptions" SIZE=1>
				<?
				if (!$htmlOptions) {
					if (strpos(" $myText", "<")) {
						$htmlOptions="contains";
					}
				}
				?>
				<OPTION VALUE="format"<? if ($htmlOptions=="format") { echo " SELECTED"; } ?>><? echo lang('add html line-breaks'); ?></OPTION>
				<OPTION VALUE="contains"<? if ($htmlOptions=="contains") { echo " SELECTED"; } ?>><? echo lang('contains html (do nothing)'); ?></OPTION>
				<OPTION VALUE="pre"<? if ($htmlOptions=="pre") { echo " SELECTED"; } ?>><? echo lang('preserve formatting (pre)'); ?></OPTION>
				</SELECT><BR>
				<FONT COLOR="<? echo $this->DARKCOLOR ?>" STYLE="font-size: 10px;"><? echo lang('if you select a file'); ?>
				</TD>								
			</TR>						
			<?
			}
			?>
			<TR>
				<TD VALIGN="top" BGCOLOR="#FFFFFF" WIDTH=100% COLSPAN=2><NOBR>
				<? echo ($this->TREEFONT); ?>
				</FONT><!--<INPUT TYPE="button" NAME="save" VALUE="save" onClick="changeItem1('save')">-->
				<INPUT TYPE="button" NAME="checkin" VALUE="<? echo lang('save'); ?>" onClick="changeItem1('checkin')">
				<!--<INPUT TYPE="button" NAME="abort" VALUE="abort" onClick="changeItem1('abort')">-->
				<INPUT TYPE="button" NAME="reset" VALUE="<? echo lang('reset'); ?>" onClick="changeItem1('reset')">				
				</NOBR></TD>
												
			</TR>																													
			</TABLE>
			<INPUT TYPE="hidden" NAME="actn" VALUE="">
			<INPUT TYPE="hidden" NAME="confirmActn" VALUE="">
			</FORM>	
			<SCRIPT LANGUAGE="Javascript">
				document.changeItem.<? echo $activeField ?>.focus();
			</SCRIPT>				
	<?
		# Abort
		if ($actn == "abort" && !$confirmActn) {
			$this->createConfirm("Are you sure you want to abort this checkout?\\nAll work since checkout will be lost.", "document.changeItem.confirmActn.value='true';\nchangeItem1('abort');\n");
		}
		# Remove Group
		if ($actn == "rmgrp" && !$confirmActn) {
			$this->createConfirm("Are you sure you want to delete the group ".$group."?", "document.changeItem.confirmActn.value='true';\nchangeItem1('rmgrp');\n");
		}
		# Reset
		if ($actn == "reset" && !$confirmActn) {
			if ($id) {
				$text  = lang('are you sure you want to reset the item');
				$text .= " '".$this->getTreeText ($id)."'?\\n";
				$text .= lang('all changes made since you last saved will be lost.');
			} else {
				$text = lang('are you sure you want to reset form?');
				}
			$this->createConfirm($text, "document.changeItem.confirmActn.value='true';\nchangeItem1('reset');\n");
		}
		# Save
		if ($actn == "save" && !$confirmActn) {
			if ($id) {
				$text  = lang('save the item');
				$text .= " '".$this->getTreeText ($id)."'?";
			} else {
				$text = lang('are you sure you want to create this new item?');
				}
			$this->createConfirm($text, "document.changeItem.confirmActn.value='true';\nchangeItem1('save');\n");
		}
		# Check In
		if ($actn == "checkin" && !$confirmActn) {
			if ($id) {
				$text  = lang('save the item');
				$text .= " '".$this->getTreeText ($id)."'?";
			} else {
				$text = lang('save this new item?');
				}
				
			$this->createConfirm($text, "document.changeItem.confirmActn.value='true';\nchangeItem1('checkin');\n");
		}
	
	}
	
	
	# This function creates a select html form element given the parameters
	# $sql_a = array of SQL statements to process
	# $name = name of form element
	# $selectedItem = selected item in the list
	# $size = size of form element (ie. 1 = drop down)
	# $default = default form item
	# any extra text to place in <SELECT> tag
	function createSelect ($sql_a, $name, $selectedItem, $size, $default, $extra, $extra_array) {
		echo ("<SELECT NAME='".$name."' SIZE=".$size." ".$extra.">\n");
		
		if ($default) {
			echo ("<OPTION>".$default."</OPTION>");
			$itemsAdded = $default;
		}
		for($x=sizeof($sql_a)-1; $x >=0; $x--) {
			$sql = $sql_a[$x];
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("createSelect (1549)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

			while ($row = mysql_fetch_array ($myresult)) {
				if ($selectedItem == $row[0] && $selectedItem && !strstr ($itemsAdded, $row[0])) {
					$option = "<OPTION SELECTED>";
					echo ($option.$row[0]."</OPTION>");
				}
				else if (!strstr ($itemsAdded, $row[0])) {
					$option = "<OPTION>";
					echo ($option.$row[0]."</OPTION>");
				}
				$itemsAdded .= $row[0];
			}
			mysql_free_result ($myresult);
			
		if ($extra_array) {
		    while (list ($key, $val) = each ($extra_array) ) {
			$option = "<OPTION>";
			echo ($option.$val."</OPTION>");
			}
		    }	
		}
		
		echo ("</SELECT>\n");
	
	}
	
	
	# This function creates the appropriate indentation given the specified directory
	function createIndent ($id) {
		global $cp_mv;
		
		# Root dir
		if ($id == $this->ROOTDIR)
			return "";
	
		# Determine if item is selected
		$preIMG = $this->createIndentURL ("m.gif");
		if ($id == $this->ROOTDIR) {
			$isSelected = true;
			$preIMG = "";
		}
		else if (($this->isChild($id,$this->ADIR)) || $this->ADIR == $id)
			$isSelected = true;
		else
			$isSelected = false;
	
		if ($id < 1000000) {
			$dir = true;
			$x = 1;
		}
		else {
			$dir = false;
			$x = 0;
		}
			
		# Top Level Directory
		if ($id == $this->ROOTDIR) {
			if ($dir && $this->hasChildren($id)) {
				if ($isSelected)
					$indent = $this->createItemURL ($this->getParentID($id), "", $cp_mv).$this->createIndentURL ("tl.gif")."</A>";
				else
					$indent = $this->createItemURL ($id, "", $cp_mv).$this->createIndentURL ("tm.gif")."</A>";
			}
			else
				$indent = $this->createIndentURL ("m.gif");
		
		}
		
		# Bottom level Item
		else if ($this->isBottom($id)) {
			if ($dir && $this->hasChildren($id)) {
				if ($isSelected)
					$indent = $this->createItemURL ($this->getParentID($id), "", $cp_mv).$this->createIndentURL ("bl.gif")."</A>";
				else
					$indent = $this->createItemURL ($id, "", $cp_mv).$this->createIndentURL ("bm.gif")."</A>";
			}
			else {
				if ($id>1000000) {
					$indent = $this->createIndentURL ("be.gif");
				}
				else {
					if ($this->hasItem($this->getParentID($id))) {
						$indent = $this->createIndentURL ("me.gif");
					}
					else {
						$indent = $this->createIndentURL ("be.gif");
					}
				}
			}
		
		}
		# Middle level item
		else {
			if ($dir && $this->hasChildren($id)) {
				if ($isSelected)
					$indent = $this->createItemURL ($this->getParentID($id), "", $cp_mv).$this->createIndentURL ("bl.gif")."</A>";
				else
					$indent = $this->createItemURL ($id, "", $cp_mv).$this->createIndentURL ("bm.gif")."</A>";
			}
			else
				$indent = $this->createIndentURL ("me.gif");
		
		}

		if ($this->getParentID($id) == $this->ROOTDIR)
			$preIMG = "";
		else {		
			# Add preceding images
			$parc=$this->countParents ($id);
			$offset=2;
			if ($parc>1 && $id>1000000) {
				$offset=1;
			}
			for ($x=0; $x < $parc - $offset; $x++) {
				$img="m.gif";
				$par=$this->getParentId($id);
				for ($n=0; $n<($parc-$offset-$x-1); $n++) {
					$par=$this->getParentId($par);
				}
				if ($parpar=$this->getParentID($par)) {
					if ($this->useBlankGif($parpar,$par)) {
						$img="blank.gif";
					}
				}
				$preIMG.=$this->createIndentURL ($img);
			}
		}
		
		return ($preIMG.$indent);
	
	}
	
	
	# This function determines if the directory specified is the last directory in it's parent
	function useBlankGif($dir,$childDir) {
		if ($dir && $childDir) {
			if ($this->hasItem($dir) && $this->showItems) {
				return false;
			}
			if (!$this->isLastDir($dir, $childDir)) {
				return false;
			}
		}
		return true;
	}
	function isLastDir($dir, $childDir) {
		if ($dir && $childDir) {
			$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$dir." ORDER BY sTopic DESC";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("isLastDir (1926)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				if ($row[0]==$childDir) {
					$returnValue=true;
				}
			}
			mysql_free_result ($myresult);
		}
		return $returnValue;
	}
	function hasItem ($dir) {
		if ($dir) {
			$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID=".$dir;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("isLastDir (1917)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			if (mysql_num_rows ($myresult) != 0) {
				$returnValue = true;
			}
			mysql_free_result ($myresult);
		}
		return $returnValue;
	}
	
	
	# This function determines if a directory has children and returns that number
	function hasChildren ($dir) {
		if ($dir) {
			$children = 0;
			$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$dir;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("hasChildren (1111)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			$children = mysql_num_rows ($myresult);
			mysql_free_result ($myresult);
			
			$sql = "SELECT iTopicID FROM tblTopicItems WHERE iTopicID=".$dir;
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("hasChildren (1116)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			$children = $children + mysql_num_rows ($myresult);
			mysql_free_result ($myresult);
			
			if ($children != 0)
				return $children;
			else
				return false;
		}
	}
	
	
	# This function determines if an items is at the bottom of the current tree level
	function isBottom ($id) {
		$returnValue = false;
		
		if ($id) {
			if ($id < 1000000)
				$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID = ".$this->getParentID($id). " ORDER BY sTopic DESC";
			else
				$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID = ".$this->getParentID($id). " ORDER BY sTitle DESC";
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("isBottom (1111)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				if ($id == $row[0])
					$returnValue = true;
			}
			mysql_free_result ($myresult);
		}
		
		return $returnValue;
	
	}
	
	
	# This function counts the number of parents that an item has
	function countParents ($id) {
		if ($id) {
			$parents = 0;
			if ($id < 1000000)
				$sql = "SELECT iParentID FROM tblTopics WHERE iTopicID = ".$id;
			else
				$sql = "SELECT iParentID FROM tblTopics WHERE iTopicID = ".$this->getParentID($id);
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("countParents (1174)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				if ($row[0] == $this->ROOTDIR)
					$parents = 1;
				else
					$parents = 1 + $this->countParents($row[0]);
			}
			mysql_free_result ($myresult);
			
			return $parents;
		}
	}
	
	
	# This function returns the url for an indentation images
	function createIndentURL ($img) {
		return ("<IMG SRC='".$this->IMGURL.$img."' HEIGHT=18 WIDTH=20 ALIGN='left' HSPACE=0 VSPACE=0 BORDER=0>");
	}
	
	
	# This function creates the url necessary for the specified id
	function createItemURL ($id, $statusText, $cp_mv) {

		//if ($this->SESSION) {
		//    $href = $this->APPURL . "?dir=";
		//    } else {
		//    $href = $this->APPURL . "&dir=";
		//    }
		    
		$statusText=str_replace("'", "", $statusText);
		# Find parent directory if this is an item
		if ($id >= 1000000) {
			$dir = $this->getParentID($id);
			$item = $id;
		}
		else
			$dir = $id;

		if (!$item) {
			return ("<A HREF='javascript:submitformdir(".$dir.")' onMouseOver='javascript: window.status=\"".$statusText."\"; return true;' onMouseOut='javascript: window.status=\"\"; return true;' STYLE='text-decoration: none'>");
			//return ("<A HREF='$href".$dir."&sel=".$id."&cat=".$cp_mv."&sortmethod=".$this->SORTMETHOD."&viewoption=".$this->VIEWOPTION."&id=".$id."' onMouseOver='javascript: window.status=\"".$statusText."\"; return true;' onMouseOut='javascript: window.status=\"\"; return true;' STYLE='text-decoration: none'>");
		} else {
			return ("<A HREF='javascript:submitformitem(".$dir.",".$item.")' onMouseOver='javascript: window.status=\"".$statusText."\"; return true;' onMouseOut='javascript: window.status=\"\"; return true;' STYLE='text-decoration: none'>");
			//return ("<A HREF='$href".$dir."&sel=".$item."&cat=".$cp_mv."&sortmethod=".$this->SORTMETHOD."&viewoption=".$this->VIEWOPTION."&id=".$id."' onMouseOver='javascript: window.status=\"".$statusText."\"; return true;' onMouseOut='javascript: window.status=\"\"; return true;' STYLE='text-decoration: none'>");
		}
	}
	
	
	# This function creates the javascript necessary to close the window
	function closeWindow($id) {
	?>
	<SCRIPT LANGUAGE="Javascript">
		<?
		if ($id) {
			# Directory
			if ($id < 1000000)
				echo ("window.opener.submitformdir (".$id.");\n");
			else
				echo ("window.opener.submitformitem (".$this->getParentID($id).",".$id.");\n");
		}
		?>
		window.close();	
	</SCRIPT>
	<?
	}
	
	
	# This function creates a javascript confirmation to verify that a use wishes to perform a certain task
	function createConfirm($msg, $actn) {
	?>
	<SCRIPT LANGUAGE="Javascript">
		if (confirm ("<? echo $msg ?>")) {
			<? echo $actn ?>
		}
	</SCRIPT>
	<?
	}
	
	
	# This function creates a javascript alert
	function createAlert($msg) {
	?>
	<SCRIPT LANGUAGE="Javascript">
		alert ("<? echo $msg ?>");
	</SCRIPT>
	<?
	}	
	
	
	# This function removes a group based on the group name passed
	function removeGroup ($group) {

		# Check if user has permission to delete group
		$groupID = $this->getGroupID ($group, $global , false);
		
		# Determine group id
		if (!$groupID) {
			$returnValue = "Unable to delete the group ".$group.". You may not have access.";
		}
		else {
			$user = $this->getGroupUser ($groupID);
		}
		
		if (!$returnValue) {
			# User cannot delete other user's directories
			if (!$global && $user != $this->USER) {
				$returnValue = "You cannot delete another user's private group";
			}
			# Check if user has access to add a global group
			else if ($global && $this->accessLevel ($this->ROOTDIR) < 2) {
				$returnValue = "You do not have access to remove a Global Group. You may only remove your own Private Groups";
			}
		}
		
		# Delete group
		if (!$returnValue) {
			$sql = "DELETE FROM tblGroups WHERE iGroupID=".$groupID;
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("removeGroup (1353)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		
			$sql = "DELETE FROM tblGroupPermissions WHERE iGroupID=".$groupID;
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("removeGroup (1358)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				
			$sql = "DELETE FROM tblGroupMembers WHERE iGroupID=".$groupID;
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("removeGroup (1361)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		}
		
		return $returnValue;
	
	}
	
	
	# This function adds a group based on the criteria passsed and returns
	# an error if one exists
	function addGroup($newGroup,$newGroupMembers,$privateGroup,&$activeField) {
		
		$newGroup = trim($newGroup);
		$newGroupMembers = trim($newGroupMembers);
		
		if ($newGroup == "") {
			$returnValue = "Please enter a group name";
			$activeField = "newGroup";
		}
		else if ($newGroupMembers == "") {
			$returnValue = "Please enter at least one group member";
			$activeField = "newGroupMembers";
		}
		
		# Check if group name already exists
		$existingID = $this->getGroupID($newGroup, $global, true);
		if ($existingID) {
			# Global name already exists
			if ($global) {
				$returnValue = "A Global Group with this name already exists";
			}
			# Private name already exists when attempting to add global group
			else if (!$global && !$privateGroup) {
				$returnValue = "The user ".$this->getGroupUser($existingID)." has a private group with this same name. Global Group cannot be added";
			}
			# Private user group with same name already exists
			else if (!$global && $privateGroup && ($this->USER == $this->getGroupUser($existingID))) {
				$returnValue = "You already have a Private Group with this name created.";
			}
			$activeField = "newGroup";
		}
	
		# Group visibility
		if (!$returnValue) {
			
			# Adding private group
			if ($privateGroup) {
				$groupUser = "'".$this->USER."'";
			}
			# User does not have access to add a global group
			else if ($this->accessLevel ($this->ROOTDIR) < 2) {
				$returnValue = "You do not have access to add a Global Group. You may only add a Private Group";
				$activeField = "privateGroup";
			}
			# Adding Global Group
			else {
				$groupUser = "null";
			}
			
			if (!$returnValue) {
				$groupID = $this->getNewID ("iGroupID");
				
				# Add Group
				$sql = "INSERT INTO tblGroups VALUES (".$groupID.",".$groupUser.",'".$newGroup."')";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("addGroup (1831)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
									
				# Add Group Members
				$groupMembers_a = explode (",", $newGroupMembers);
				for($x=sizeof($groupMembers_a)-1; $x >=0; $x--) {
					$groupMember = trim(strtolower($groupMembers_a[$x]));
					$sql = "INSERT INTO tblGroupMembers VALUES (".$groupID.",'".$groupMember."')";
					$myresult = mysql_query ($sql)
						or die ($this->createErrorMSG("addGroup (1829)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				}
			}
		}
		
		return $returnValue;
	
	}
	
	
	# This function saves an items based on the item id returns an error if unable to process
	function saveItem(&$cat, &$id, $name, $owner, $group, $groupAccess, $worldAccess,$keywords,$updateReason,$itemText,$dirID,&$activeField,$overrideAccess) {
	
		# Check if user has permission
		if (!$overrideAccess) {
			if ($id && $this->accessLevel ($id) < 4) {
				$returnValue = "You do not have permission to modify this item";
				$activeField = "owner";
			}
			else if (!$id && $this->accessLevel ($dirID) < 2) {
				$returnValue = "You do not have permission to create this item";
				$activeField = "owner";
			}
		}
		
		# Bad parent
		if ($id == $dirID) {
			$dirID = $this->getParentID($dirID);
		}
		
		if (!$group) {
		    $group = "none";
		}
		    
		# Check for blank fields
		if (!$name) {
			$returnValue = "Invalid name!";
			$activeField = "name";
		}
		else if (!$owner) {
			$returnValue = "Invalid owner!";
			$activeField = "owner";
		}
		else if (!$group) {
			$returnValue = "Invalid group!";
			$activeField = "group";
		}
		else if (!$groupAccess && $group != "none") {
			$returnValue = "Invalid group access level!";
			$activeField = "groupAccess";
		}
		else if (!$worldAccess) {
			$returnValue = "Invalid world access level!";
			$activeField = "worldAccess";
		}
		else if (!$keywords) {
			$keywords="none";
			//$returnValue = "Invalid keywords, enter 'none' if you wish none!";
			//$activeField = "keywords";
		}
		else if (($cat == "newitemform" || $cat == "itemform") && !$itemText) {
			$returnValue = "Invalid item text";
			$activeField = "itemText";
		}
		else if ($dirID == "") {
			$returnValue = "Invalid parent directory, please close this form and try again.";
		}
		
		$name = $this->cleanStrPut($name);
		$owner = $this->cleanStrPut($owner);
		$group = $this->cleanStrPut($group);
		$keywords = $this->cleanStrPut($keywords);
		$updateReason = $this->cleanStrPut($updateReason);
		$itemText = $this->cleanStrPut($itemText);
		
		# Check for complex errors
		if (!$returnValue) {
			# Group does not exist
			if ($group != "none") {
				$groupID = $this->getGroupID($group,$global,false);
				if (!$groupID) {
					$returnValue = "Unable to locate group: ".$group;
					$activeField = "group";
				}
			}
			else
				$groupID = 0;
				
			# Permissions
			$worldAccessID = $this->getPermissionID($worldAccess);
			$groupAccessID = $this->getPermissionID($groupAccess);
			
			# World Permissions do not exit
			if ($worldAccessID == -1) {
				$returnValue = "Invalid world permissions: ".$worldAccess;
				$activeField = "worldAccess";
			}
			
			# Group Permissions do not exit
			if ($groupAccessID == -1 && $group != "none") {
				$returnValue = "Invalid group permissions: ".$groupAccess;
				$activeField = "groupAccess";
			}
			
		}
		
		# Process Save
		if (!$returnValue) {
			$del = true;
			# Item
			if ($cat == "newitemform" || $cat == "itemform") {
				# New Item
				if ($cat == "newitemform") {
					# Get item id
					$del = false;
					$id = $this->getNewID("iTopicItemID");
					$cat = "itemform";

				}
				# Update Item
				else {
					$sql = "DELETE FROM tblTopicItems WHERE iTopicItemID=".$id;
					$myresult = mysql_query ($sql)
						or die ($this->createErrorMSG("saveItem (1589)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				}
				
				$sql = ("INSERT INTO tblTopicItems VALUES (".$id.",".$dirID.",'".$name."','".$itemText."')");
			
			}
			# Dir
			else {
				# New dir
				if ($cat == "newdirform") {
					# Get item id
					$del = false;
					$id = $this->getNewID("iTopicID");
					$cat = "dirform";

				}
				# Update Item
				else {
					$sql = "DELETE FROM tblTopics WHERE iTopicID=".$id;
					$myresult = mysql_query ($sql)
						or die ($this->createErrorMSG("saveItem (1596)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				}
				
				$sql = ("INSERT INTO tblTopics VALUES (".$id.",".$dirID.",'".$name."')");
			
			}
			# Update item record
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("saveItem (1604)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		
			# Delete existing information
			if ($del) {
				$sql = "DELETE FROM tblOwner WHERE iOwner=".$id;
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1613)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

				$sql = "DELETE FROM tblPermissions WHERE iOwner=".$id;
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1617)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
					
				$sql = "DELETE FROM tblGroupPermissions WHERE iOwner=".$id;
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1621)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
				$sql = "DELETE FROM tblKeywords WHERE iOwner=".$id;
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1625)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
					
				$sql = "DELETE FROM tblModified WHERE iOwner=".$id;
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1632)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
			}
			
			
			# Add owner information
			$sql = "INSERT INTO tblOwner VALUES (".$id.",'".$owner."')";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("saveItem (1633)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				
			# Add modification
			$sql = "INSERT INTO tblModified VALUES (".$id.",NOW(),'".$this->USER."')";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("saveItem (1638)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				
			# Add world permissions
			if ($worldAccessID != -1) {
				$sql = "INSERT INTO tblPermissions VALUES (".$id.",".$worldAccessID.")";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1633)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			}
				
			# Add group permissions
			if ($groupAccessID != -1 && $this->getGroupID($group,$global,false)) {
				$sql = "INSERT INTO tblGroupPermissions VALUES (".$id.",".$this->getGroupID($group,$global,false).",".$groupAccessID.")";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("saveItem (1633)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			}
			
			# Add keywords
			if (strtolower($keywords) != "none") {
				$keywords_a = explode (",", $keywords);
				for($x=sizeof($keywords_a)-1; $x >=0; $x--) {
					$keyword = $keywords_a[$x];
					$sql = "INSERT INTO tblKeywords VALUES (".$id.",'".trim($keyword)."')";
					$myresult = mysql_query ($sql)
						or die ($this->createErrorMSG("saveItem (1662)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				}
			}
			
		
		}
		
	
		return $returnValue;
	
	}
	
	
	# This function returns the group id for the specified group and sets the
	# $global attribute to true if it is a global group. If $includePrivate then
	# searches through all private
	function getGroupID($group, &$global,$includePrivate) {
		
		if ($includePrivate) {
			$sql = "SELECT iGroupID FROM tblGroups WHERE sGroupName = '".$group."' and sUser='".$this->USER."'";
		}
		else {
			$sql = "SELECT iGroupID FROM tblGroups WHERE sGroupName = '".$group."' AND sUser is not null";
		}
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getGroupID (1428)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

		if (mysql_num_rows ($myresult) != 0) {
			$row = mysql_fetch_array ($myresult);
			$returnValue = $row[0];
			$global = false;
		}
		mysql_free_result ($myresult);
		
		if (!$returnValue) {
			$sql = "SELECT iGroupID FROM tblGroups WHERE sGroupName = '".$group."' and sUser is null";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getGroupID (2096)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$returnValue = $row[0];
				$global = true;
			}
			mysql_free_result ($myresult);
		}
		
		return $returnValue;
	
	}
	
	
	# This function returns the group user for the specified group id
	function getGroupUser ($groupID) {
		
		if ($groupID && $groupID != "") {
			$sql = "SELECT sUser FROM tblGroups WHERE iGroupID = ".$groupID;
				
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getGroupUser (2100)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$returnValue = $row[0];
			}
			mysql_free_result ($myresult);
			
			return $returnValue;
		}
		
	}
	
	
	# This function returns the permission level for the specified permission description
	function getPermissionID($desc) {
		
		$sql = "SELECT iAccessLevel FROM tblPermissionDescriptions WHERE sDescription = '".$desc."'";
			
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getPermissionID (1583)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));

		if (mysql_num_rows ($myresult) != 0) {
			$row = mysql_fetch_array ($myresult);
			$returnValue = $row[0];
		}
		else
			$returnValue = -1;
			
		mysql_free_result ($myresult);
		
		return $returnValue;
	
	}
	
	
	# This function cleans the string for preparation for entering it into the database
	function cleanStrPut($str) {
		$str = str_replace("\\\\", "\\", $str);
		$str = str_replace("'", "\'", $str);
		$str = str_replace("\\\\'", "\'", $str);
		$str = str_replace("\\\'", "\'", $str);
		$str = str_replace("\\'", "\'", $str);
		return trim($str);
	}
	
	
	# This function returns a new id for the field type specified
	function getNewID ($field) {
		$sql = "SELECT ".$field." FROM tblID";
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getNewID (1563)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		$row = mysql_fetch_array ($myresult);
		$id = $row[0] + 1;
		
		# Update id
		$sql = "UPDATE tblID SET ".$field."=".$id;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("getNewID (1570)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			
		return $id;
	}
	
	
	# This function returns the first item within the specified directory
	function getFirstItem ($parent) {
		return $this->getOrderedItem($parent, "ASC");
	}
	function getLastItem ($parent) {
		return $this->getOrderedItem($parent, "DESC");
	}
	function getOrderedItem($parent, $ord) {
		if ($parent && $parent < 1000000) {
			
			$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID=".$parent." ORDER BY sTitle $ord";
			$myresult = mysql_query ($sql)
				or die ($this->createErrorMSG("getFirstItem (1563)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
			if (mysql_num_rows ($myresult) != 0) {
				$row = mysql_fetch_array ($myresult);
				$returnValue = $row[0];
			}
			else
				$returnValue = "";
				
			return $returnValue;
		}
		else {
			return "";
		}
	}
	
	
	# This function cleans the string from a form
	function cleanStrGet($str) {
		$str = str_replace("\'", "'", $str);
		$str = str_replace("\\\"", chr(34), $str);
		return trim($str);
	}
	
	
	# This function attempts to copy or move the element specified by id into the directory
	# specified by dirID. It returns true if the action was successful or an error message
	# if otherwise
	function cpMvElement($cat, &$id, $dirID, $newName) {
		
		# Check if user has access to perform this task
		$accessLevel1 = $this->accessLevel ($id);
		$accessLevel2 = $this->accessLevel ($dirID);
		
		if ($accessLevel1 < 2 || $accessLevel2 < 2) {
			$errorMsg = "You do not have access to perform this action.";
		}
		
		# Check if the two elements are the same
		if ($errorMsg == "") {
			if ($id == $dirID && $cat == "mv") {
				$errorMsg = "You cannot move a directory into itself";
			}
		}
		
		# Check if attempting to copy into same dir without new name
		if ($errorMsg == "") {
			if ($id >= 1000000 && $this->getParentID ($id) == $dirID && $cat == "cp" && trim($newName) == "") {
				$errorMsg = "You cannot copy an element into the same directory without renaming the element.";
			}
		}
		
		# Check if attempting to copy a directory into itself
		if ($errorMsg == "") {
			if ($id == $dirID || $this->isChild($id, $dirID)) {
				$errorMsg = "You cannot copy a directory into itself, nor into one of its' child directories.";
			}
		}
		
		# Check if attempting to move diretory into child directory
		if ($errorMsg == "") {
			if ($id < 1000000 && $this->isChild($id, $dirID) && $cat == "mv") {
				$errorMsg = "You cannot move a directory into a child directory.";
			}
		}
		
		# Check if target dir and element both exist
		if ($errorMsg == "") {
			if (!$this->getTreeText ($id) || !$this->getTreeText ($dirID)) {
				$errorMsg = "An error has occured. Please verify that both elements involved still exist.";
			}
		}
		
		# Check if target dir is a directory
		if ($errorMsg == "") {
			if ($dirID >= 1000000) {
				$errorMsg = "Target is not a directory";
			}
		}
		
		# Check if attempting to copy or move root item
		if ($errorMsg == "") {
			if ($id == $this->ROOTDIR) {
				$errorMsg = "Cannot move or copy root directory";
			}
		}
		
		# Move
		if ($errorMsg == "" && $cat == "mv") {
			# Update name if specified
			if (!trim($newName) == "") {
				$this->updateName($id, trim($newName));
			}
			$this->updateParent($id, $dirID);
		}
		# Copy
		else if ($errorMsg == "" && $cat == "cp") {
			# Copy item
			if ($id >= 1000000) {
				$id = $this->copyElement($id, $dirID, $newName);
			}
			# Copy directory
			else {
				$oldID = $id;
				$id = $this->copyElement($id, $dirID, $newName);
				$this->copyDir($id, $oldID);
			}
		}
		
		
		if ($errorMsg == "") {
			return true;
		}
		else {
			return $errorMsg;
		}
	}
	
	
	# This method updates the parent for the element specified by $id
	# to the element specified by $dirID
	function updateParent($id, $dirID) {
		
		if ($id < 1000000) {
			$sql = "UPDATE tblTopics SET iParentID=".$dirID." WHERE iTopicID=".$id;
		}
		else {
			$sql = "UPDATE tblTopicItems SET iTopicID=".$dirID." WHERE iTopicItemID=".$id;
		}
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("updateParent (2126)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
	}
	
	
	# This method updates an elements name specified by $id
	function updateName($id, $newName) {
		
		if ($id < 1000000) {
			$sql = "UPDATE tblTopics SET sTopic='".$newName."' WHERE iTopicID=".$id;
		}
		else {
			$sql = "UPDATE tblTopicItems SET sTitle='".$newName."' WHERE iTopicItemID=".$id;
		}
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("updateParent (2126)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
	
	}
	
	
	# This method copies an element and returns the new id
	function copyElement($id, $dirID, $newName) {
		
		# Get element properties
		$this->getProperties ($id, $name, $owner, $dtLastModified, $lmUser, $worldAccessNum, $worldAccess, $group, $groupAccessNum, $groupAccess);
		if (trim($newName) == "") {
			$newName = $name;
		}
		$newID = "";
	
		# Item
		if ($id >= 1000000) {
			$cat = "newitemform";
			$itemText = $this->getItemText($id);
		}
		# Directory
		else {
			$cat = "newdirform";
			$itemText = "";
		}
		
		# Attempt to copy item or directory. If successful then return new id
		$errorMsg = $this->saveItem($cat, $newID, $newName, $owner, $group, $groupAccess, $worldAccess,$this->getKeywords($id),"Document Created",$itemText,$dirID,$activeField, false);
		if ($errorMsg) {
			echo $errorMsg;
			return false;
		}
		else {
			# Perform any binary file operations
			if (strstr($itemText, "PHPTREEFILE")) {
				$sql="SELECT data, type, size FROM tblTopicItemFile WHERE iTopicItemID=$id";
				$myresult = mysql_query ($sql)
					or die ($this->createErrorMSG("copyElement (2588)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				if ($row = mysql_fetch_array ($myresult)) {
					$data = addslashes($row[0]);
					$type = $row[1];
					$size = $row[2];
				}
				mysql_free_result ($myresult);
				if ($data && $type && $size) {
					$sql = "INSERT INTO tblTopicItemFile (iTopicItemID, data, type, size) VALUES ($newID, '$data', '$type', '$size')";
					$myresult = mysql_query ($sql)
						or die ($this->createErrorMSG("printObjectForm (1389)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
				}
			}
			return $newID;
		}
	}
	
	
	# This function copies all of the elements of a directory into a new directory
	function copyDir($newID, $oldID) {
		
		# Copy all directory items
		$sql = "SELECT iTopicItemID FROM tblTopicItems WHERE iTopicID=".$oldID;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("copyDir (2208)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		while ($row = mysql_fetch_array ($myresult)) {
			$this->copyElement($row[0], $newID, "");
		}
		mysql_free_result ($myresult);
		
		# Copy all directories
		$sql = "SELECT iTopicID FROM tblTopics WHERE iParentID=".$oldID;
		$myresult = mysql_query ($sql)
			or die ($this->createErrorMSG("copyDir (2217)", "Unable to run query: <BR><PRE>".$sql."</PRE>"));
		while ($row = mysql_fetch_array ($myresult)) {
			$oldChildID = $row[0];
			$newChildID = $this->copyElement($oldChildID, $newID, "");
			$this->copyDir($newChildID, $oldChildID);
		}
		mysql_free_result ($myresult);
		
	}
	
	
	# This function creates the appropriate font tag for a form element
	# header (font uses ERRORCOLOR for errors)
	function createFontTag($error,$activeField,$tagField) {
		echo ($this->TREEFONT); 
		if ($error && $activeField==$tagField) {
			echo "<FONT COLOR='".$this->ERRORCOLOR."'>";
		}
	}

	
} # end class HTMLTree

?>