<?php
	/**************************************************************************\
	* phpGroupWare - PHPtree                                                   *
	* http://www.phpgroupware.org                                              *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/

	/* $Id: setup.inc.php,v 1.4.2.1 2002/04/27 15:34:19 skeeter Exp $ */

	/* Basic information about this app */
	$setup_info['phptree']['name']      = 'phptree';
	$setup_info['phptree']['title']     = 'PHPtree';
	$setup_info['phptree']['version']   = '0.8.1';
	$setup_info['phptree']['app_order'] = 8;
	$setup_info['phptree']['enable']    = 1;

	$setup_info['phptree']['author'] = 'Jason Read';
	$setup_info['phptree']['note'] = 'Ported in Phpgroupware by Sam Przyswa';
	$setup_info['phptree']['license']  = 'GPL';
	$setup_info['phptree']['description'] = 'File tree management system.';
	$setup_info['phptree']['maintainer'] = 'Sam Przyswa';
	$setup_info['phptree']['maintainer_email']    = 'samp@arial-concept.com';

	/* The tables this app creates */
	$setup_info['phptree']['tables']    = array(
		'tblGroupMembers',
		'tblGroupPermissions',
		'tblID',
		'tblKeywords',
		'tblModified',
		'tblOwner',
		'tblPermissionDescriptions',
		'tblPermissions',
		'tblTopicItemFile',
		'tblTopicItems',
		'tblTopics',
		'tblUserSelection',
		'tblGroups'
	);

	/* The hooks this app includes, needed for hooks registration */
	// $setup_info['phptree']['hooks'][] = 'admin';
	$setup_info['phptree']['hooks'][] = 'preferences';

	/* Dependencies for this app to work */
	$setup_info['phptree']['depends'][] = array(
		 'appname' => 'phpgwapi',
		 'versions' => Array('0.9.10', '0.9.11' , '0.9.12', '0.9.13', '0.9.14')
	);
		
?>
