<?php
  /**************************************************************************\
  * phpGroupWare - PHPtree                                                   *
  * http://www.phpgroupware.org                                              *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

  /**************************************************************************\
  * This file should be generated for you by setup. It should not need to be *
  * edited by hand.                                                          *
  \**************************************************************************/

  /* $Id: tables_current.inc.php,v 1.0 2001/05/28 08:42:04 username Exp $ */

  /* table array for phptree */
	$phpgw_baseline = array(
		'tblGroupMembers' => array(
			'fd' => array(
				'iGroupID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sUser' => array('type' => 'varchar', 'precision' => 20,'nullable' => False)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('iGroupID'),
			'uc' => array()
		),
		'tblGroupPermissions' => array(
			'fd' => array(
				'iOwner' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iGroupID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iAccessLevel' => array('type' => 'int', 'precision' => 2,'nullable' => False)
			),
			'pk' => array('iOwner'),
			'fk' => array(),
			'ix' => array('iGroupID'),
			'uc' => array()
		),
		'tblID' => array(
			'fd' => array(
				'iTopicID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iTopicItemID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iGroupID' => array('type' => 'int', 'precision' => 4,'nullable' => False)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('iTopicID'),
			'uc' => array()
		),
		'tblKeywords' => array(
			'fd' => array(
				'iOwner' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sKeyword' => array('type' => 'varchar', 'precision' => 25,'nullable' => False)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('iOwner'),
			'uc' => array()
		),
		'tblModified' => array(
			'fd' => array(
				'iOwner' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'dtLastModified' => array('type' => 'date','nullable' => False,'default' => '0000-00-00'),
				'sUser' => array('type' => 'varchar', 'precision' => 20,'nullable' => False)
			),
			'pk' => array('iOwner'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		),
		'tblOwner' => array(
			'fd' => array(
				'iOwner' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sUser' => array('type' => 'varchar', 'precision' => 20,'nullable' => False)
			),
			'pk' => array('iOwner'),
			'fk' => array(),
			'ix' => array('sUser'),
			'uc' => array()
		),
		'tblPermissionDescriptions' => array(
			'fd' => array(
				'iAccessLevel' => array('type' => 'int', 'precision' => 2,'nullable' => False),
				'sDescription' => array('type' => 'varchar', 'precision' => 10,'nullable' => False)
			),
			'pk' => array('iAccessLevel'),
			'fk' => array(),
			'ix' => array('sDescription'),
			'uc' => array()
		),
		'tblPermissions' => array(
			'fd' => array(
				'iOwner' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iAccessLevel' => array('type' => 'int', 'precision' => 2,'nullable' => False)
			),
			'pk' => array('iOwner'),
			'fk' => array(),
			'ix' => array('iAccessLevel'),
			'uc' => array()
		),
		'tblTopicItemFile' => array(
			'fd' => array(
				'iTopicItemID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'data' => array('type' => 'blob', 'nullable' => True),
				'size' => array('type' => 'varchar', 'precision' => 50,'nullable' => True),
				'type' => array('type' => 'varchar', 'precision' => 50,'nullable' => True)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('iTopicItemID'),
			'uc' => array()
		),
		'tblTopicItems' => array(
			'fd' => array(
				'iTopicItemID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iTopicID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sTitle' => array('type' => 'varchar', 'precision' => 50,'nullable' => False),
				'sTopicItem' => array('type' => 'text','nullable' => False)
			),
			'pk' => array('iTopicItemID'),
			'fk' => array(),
			'ix' => array('iTopicID'),
			'uc' => array()
		),
		'tblTopics' => array(
			'fd' => array(
				'iTopicID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iParentID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sTopic' => array('type' => 'varchar', 'precision' => 50,'nullable' => False)
			),
			'pk' => array('iTopicID'),
			'fk' => array(),
			'ix' => array('iParentID'),
			'uc' => array()
		),
		'tblUserSelection' => array(
			'fd' => array(
				'sUser' => array('type' => 'varchar', 'precision' => 20,'nullable' => False),
				'iRootDir' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'iSelectedTopicID' => array('type' => 'int', 'precision' => 4,'nullable' => True),
				'iSelectedTopicItemID' => array('type' => 'int', 'precision' => 4,'nullable' => True),
				'iSortMethod' => array('type' => 'int', 'precision' => 2,'nullable' => True),
				'iViewOption' => array('type' => 'int', 'precision' => 2,'nullable' => True)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('sUser'),
			'uc' => array()
		),
		'tblGroups' => array(
			'fd' => array(
				'iGroupID' => array('type' => 'int', 'precision' => 4,'nullable' => False),
				'sUser' => array('type' => 'varchar', 'precision' => 20,'nullable' => True),
				'sGroupName' => array('type' => 'varchar', 'precision' => 50,'nullable' => False)
			),
			'pk' => array('iGroupID'),
			'fk' => array(),
			'ix' => array('sGroupName'),
			'uc' => array()
		),
	);
?>